<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}

include $d_root.'admin/classes/upload.php';

include $d_root.'includes/glob.php';

class CoreInstall {
    var $xml = false; //object
	var $type = false;
    var $installer_file;
    var $install_dir = false;
    var $install_to = false;
	var $subsites = null;
	var $error = false;
	var $was_archive = false;
	var $version = '';
	var $fs;
	
	function CoreInstall() {
		global $d_root;
		include $d_root.'admin/classes/fs.php';

		$this->fs = new FS(); 
	}

    function findInstallFile()
    {
		// Try to find the package XML file
		$files = safe_glob($this->install_dir.'*.xml');
		if (!count($files))
			return false;
		foreach($files as $file) {
			$pkg = $this->isPackageFile(substr($file, strlen($this->install_dir)));
			if (isset($pkg)) {
				$this->xml =& $pkg;
				return true;
			}
		}
		return false;
    }

    function &isPackageFile($p_file)
    {
        $xmlDoc = new AnyXML();
		if (!$xmlDoc->fromString(file_get_contents($this->install_dir.$p_file)))
			$xmlDoc = null;
		else
			$this->installer_file = $p_file;
		return $xmlDoc;
    }
	
	function isValid() {
        if ($this->xml->getName() != 'dkinstall')
			return false;
		$this->version = $this->xml->attributes('version');
		return true;
	}


    function queries(&$obj, $path)
    {
        global $conn;
        $query_element = $obj->getElementByPath($path);
        if (isset($query_element)) {
            $queries = $query_element->getAllChildren();
			if (!count($queries))
				return;
            foreach($queries as $query) {
                if (!@$conn->Execute($query->getValue()))
					echo '<p>'.$conn->ErrorMsg().'</p>';
            }
        }
    }
	
	function Cleanup() {
		// provide cleanup of temporary folders
		if ($this->was_archive)
			$this->fs->deldir($this->install_dir);
	}

    function from_dir($dir)
    {
		if ($dir{strlen($dir)-1}!='/') $dir.='/';
        $this->install_dir = $dir;
    }

    function get_installer()
    {
        global $package_file, $package_url, $package_dir, $d_root, $d_private;
        // check url
        if (strlen(str_replace("http://", "", $package_url)) > 7) {
            // download file -> unzip -> from dir
			$tmp_file = $d_root.$d_private.md5($package_url);
			if (is_file($tmp_file))
				$this->fs->deldir($tmp_file);
            get_url($package_url, $tmp_file);
			$package_dir = $tmp_file.'_ext';
			$this->extract_file($tmp_file, $package_dir);
			$this->fs->unlink($tmp_file);
			$this->install_dir = $package_dir.'/';
            $this->was_archive = true;
			return true;
        }
		$upload = in_upload('package_file', null, array('tar','gz','tgz','zip'));
		if (is_array($upload)) {
            $pfname = $upload[1];
            $src = $upload[0];
            $dest = $d_root . $d_private. $pfname;
            move_uploaded_file($src, $dest);
			$package_dir = $d_root.$d_private."install_" . $pfname;
            $this->extract_file($dest, $package_dir);
			$this->fs->unlink($dest);
			$this->install_dir = $package_dir.'/';
			$this->was_archive = true;
            return true;
        }
        if (strlen(str_replace($d_root, "", $package_dir)) > 5) {
            $this->from_dir($package_dir);
            return true;
        }

        return false;
    }
	
	function _subsites_sync(&$sql) {
		global $conn;
		if (!isset($this->subsites))
			$this->subsites = $conn->GetArray('SELECT subpath FROM #__subsites');
		if (!count($this->subsites))
			return;
		foreach ($this->subsites as $row) {
			include $d_root.$row['subpath'].'async.php';
			$conn->Execute($sql);
		}
	}

}
?>