<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Database backup class
# @author legolas558
#
# This class has been rewritten to work with adoDB lite
#

function dkdb_encode($s) {
	return str_replace("'", "''", $s);
}

class DbBackup {

	// replicate the database into the one specified by parameters
	function Replicate(&$conn) {
		$sql = file_get_contents($this->Snapshot());
		$queries = split_sql($sql); unset($sql);
		
		$err = 0;
		foreach ($queries as $query) {
			if ($conn->Execute($query) === false) {
				$err++;
			}
		}
		return $err;
	}

	// get a snapshot within the specified number of hours
	function Snapshot($hours = 0) {
		global $d_root, $d_private;
		$sql_backups = read_dir($d_root.$d_private.'backup/',"file",true, array('php'));

		$chosen = false;
		$c=count($sql_backups);
		global $time;
		for ($i=0;$i<$c;$i++) {
			$p = strpos($sql_backups[$i]['id'], '_');
			if ($p===false) continue;
			$ts = intval(substr($sql_backups[$i]['id'], 0, $p));
			if (!$ts) continue;
			if ($time-$ts>=$hours * 60 * 60) continue;
			$chosen = $d_private.'backup/'.$sql_backups[$i]['id'];
			break;
		}
		if ($chosen == false)
			$chosen = $this->Create();
		return $chosen;
	}


	function TablesFilter($tables) {
		global $d_prefix;
		$r = array();
		$l = strlen($d_prefix);
		foreach($tables as $table) {
			$table = strtolower($table);
			if ( substr($table, 0, $l) === strtolower($d_prefix) )
				$r[] = substr($table,$l);
		}
		return	$r;
	}
	
	function _meta_numeric_fix(&$meta) {
		if (!isset($meta->numeric)) {
			$meta->numeric = ( (strpos($meta->type, 'int')===0) ||
								(strpos($meta->type, 'float')!==false) ||
								(strpos($meta->type, 'numeric')!==false) ||
								(strpos($meta->type, 'decimal')!==false) ||
								(strpos($meta->type, 'double')!==false) ||
								(strpos($meta->type, 'real')!==false) );
		}
	}
	
	function MetaColumns($table) {
		global $conn, $d_prefix;
		return $conn->adodb->MetaColumns($d_prefix.$table);
	}

function Create() {
	global $conn,$d_root,$time,$d_prefix;

	$tables = $this->TablesFilter($conn->adodb->MetaTables());

	global $d_private,$time;
	$backup_filename = $d_private.'backup/'.$time.'_'.random_string(4).'_'.get_domain().".sql.php";
	$f = fopen($d_root.$backup_filename, 'wb');
	write_pdl_h($f, 5);
	write_pdl_h($f, 5); // double header for SQL files

	foreach( $tables as $table_name ) {
		$table_meta=$this->MetaColumns($table_name);

		$table = '#__'.$table_name;
		fputs($f, "DROP TABLE $table;\r\n\r\n");
		// create table query
		fputs($f, "CREATE TABLE $table (\r\n");
		fputs($f, "id INTEGER AUTO_INCREMENT");
		if ($table_meta) {
			$keys = array_keys($table_meta);
			foreach ($keys as $k) {
				$meta =& $table_meta[$k];
				$this->_meta_numeric_fix($meta);

				if( $meta->name=="id"
//				|| $key=="lastupd"
				) continue ;

				fputs($f, ",\r\n".$meta->name.' ');
				fputs($f, strtoupper($meta->type));
				if (($meta->max_length>0) && ($meta->type!=='int')) //skip display lengths
					fputs($f, "(".$meta->max_length.")");
				if($meta->not_null) fputs($f, " NOT NULL");
				if($meta->has_default) {
					fputs($f, " DEFAULT ");
					if ($meta->numeric) {
						$def = $meta->default_value;
						settype($def, 'string');
						if (strlen($def)==0) $def='0';
						fwrite($f, $def);
					} else
						fputs($f, "'".dkdb_encode($meta->default_value)."'");
				}
			}
		}
		fputs($f, ",\nPRIMARY KEY (id) \r\n);\r\n\r\n");

		$rs=$conn->Execute('SELECT * FROM '.$table);
		while ($row = $rs->GetArray(1)) {
			$row = $row[0];
			fputs($f, "INSERT INTO $table (");
			$c=count($row);

			for($i=0;$i<$c-1;$i++) {
//				if($keys[$i]=='lastupd')continue;
				fputs($f, $table_meta[$keys[$i]]->name.',');
			}
			fputs($f, $table_meta[$keys[$c-1]]->name);
			fputs($f, ") \nVALUES (");
			reset($table_meta);
			for($i=0;$i<$c;$i++) {
//				if($keys[$i]=='lastupd')continue;
				$meta =& $table_meta[$keys[$i]];
				$val = $row[$meta->name];
				$sep = ($i==$c-1) ? '': ',';
				if (!$meta->numeric)
					fputs($f, "'".dkdb_encode($val)."'".$sep);
				else {
					settype($val, 'string');
					fputs($f, $val.$sep);
				}
			}
			fputs($f, ");\r\n\r\n");
		}
	}
	//L: create a secure filename
	fclose($f);

	return $backup_filename;
}

} // DbBackup class

?>