<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Tarball backup component for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# HTML output functions
#

$skip_folders = array( $d_private.'backup/', $d_private.'cache/' );

//legolas558: tarball archiving
function manage_tar()
{
global $d_root,$d_private;
$gui=new ScriptedUI();
$gui->add("form","adminform");
$gui->add("com_header",_SYSTEM_TAR_BACKUP);

$table_head = array ( array('title'=>'#' , 'val'=>'id' , 'len'=>'1%','align'=>'center') ,
					  array('title'=>'checkbox' , 'val'=>'id' , 'len'=>'1%','align'=>'center') ,
					  array('title'=>_NAME,'val'=>'id','len'=>'70%','info'=>_DOWNLOAD,'ilink'=>
					  $d_private.'backup/ivar1','ivar1'=>'id') ,
					  array('title'=>_CDATE,'val'=>'created','len'=>'15%','date'=>'1','align'=>'center'),
					  array('title'=>_SIZE,'val'=>'size','len'=>'15%','align'=>'center') ,
					 );
$backup_dir=$d_root.$d_private."backup/";
$table_data=read_dir($backup_dir,"file",true, array('tar', 'tgz', 'gz'));
$gui->add("data_table_arr","maintable",$table_head,$table_data);
$gui->add("end_form");
$gui->generate();
}

	function continue_job($total, $done) {
		global $gui;
		$gui->add("form_text","", '<strong>'.((int)($done*100/$total)).'%</strong> '._BACKUP_COMPLETE.'<br/>' );
		$gui->add("form_hidden", "step","", 2);

//		$gui->add("form_hidden", "tarbak_tgz","", $tarbak_tgz);
		return array(array('name'=> _NEXT , 'onclick'=>'javascript:document.adminform.submit()'));
	}

function update_tarball($tar_fname, $step) {
	global $skip_folders, $d_root, $d_private, $gui;

	function update_cb(&$tar) {
		global $gui,$d;
		if (!$tar->Finished()) {
			$gui=new ScriptedUI();
			$gui->add("form","adminform");
			$gui->add("com_header",_SYSTEM_TAR_BACKUP);

			$gui->add("tab_head");
			$gui->add("tab_simple","", _BACKUP_UPDATE_IN_PROGRESS);

			$button_arr = continue_job($tar->progress->total, $tar->progress->done);

			$gui->add("bar");
			$gui->add("form_buttons","","",$button_arr);

			$gui->add("tab_tail");
			$gui->add("end_form");
			$gui->generate();
		} else
			$d->Redir('admin.php?com_option=backup', 'Archive updated successfully');
	}

	include $d_root.'admin/classes/TarBackup.php';
	global $d_rand;
	$tar = new TarBackup($_SESSION[$d_rand.'tarbackup']);

	if ($step == 0) {

		$tar_fname = $d_root.$d_private.'backup/'.$tar_fname;
		$tar->BeginUpdate($d_root, $tar_fname, $skip_folders);

		if (rev_path_matches($tar->dellist, $d_private.'backup/')) {
			include $d_root.'admin/classes/dbbackup.php';
			$dbbak = new DbBackup();
			$chosen = $dbbak->Snapshot(); unset($dbbak);
			$tar->AddFile($chosen);
		}

	} else if ($step == 2) {

		if (!isset($tar->progress))
			trigger_error('Session data lost! Restart the process');
	}

	if (!$tar->PerformUpdate('update_cb', $GLOBALS['page_start_time']-mt_float()))
		$d->Back($tar->ErrorMsg());
}

function new_tarball($step) {
global $gui;
	$gui=new ScriptedUI();
	$gui->add("form","adminform");
	$gui->add("com_header",_SYSTEM_TAR_BACKUP);
	$gui->add("form_hidden", "task", '', 'new_tar');

	function continue_cb(&$tar) {
		global $gui, $tarbak_dl,  $d_root;

		if (!$tar->Finished())
			$button_arr = continue_job($tar->progress->total, $tar->progress->done);
		else {
			$fn = $tar->GetTarballName();

			if ($tarbak_dl) {
				ob_clean();
				include_once $d_root.'includes/download.php';
				download($fn, filesize($fn));
				unlink($fn);
				exit;
			}

			$rp = substr($fn, strlen($d_root));
			$bn = basename($rp);
			$gui->add("form_text","", _SYSTEM_TARBAK_COMPLETE.'<br/><br/>'.
			'<big><a href="'.$rp.'">'.$bn.'</a></big> '.sprintf("%.2f", convert_bytes(filesize($d_root.$rp))));
			$gui->add("form_hidden", "step","", 0);
			$gui->add("form_hidden", "tarbak_del","", $bn);
			$button_arr = array(
			array('name'=> _TB_BACK , 'onclick'=>"document.location='admin.php?com_option=backup'"),
						array('name'=> _DELETE , 'onclick'=>'javascript:document.adminform.submit()'));
			$gui->add("bar");
			$gui->add("form_text","", '<strong>Note:</strong> '._BACKUP_NOTICE);
		}
		$gui->add("bar");
		$gui->add("form_buttons","","",$button_arr);
	}

	switch ($step) {
	case 0:

	$gui->add("tab_head");
	$gui->add("tab_simple","", _BACKUP_TARBAK_OPTIONS);

	global $d_private;
	$gui->add("form_text","", sprintf(_BACKUP_TARBAK_INTRO , '<strong>'.$d_private.'backup/</strong>').'<br/>'._BACKUP_TARBAK_START);
	$gui->add("form_boolean", 'tarbak_dl', _BACKUP_TARBAK_AUTO_DL, 0);
	$gui->add("form_text","", _BACKUP_TARBAK_GZ);
	$gui->add("form_boolean", 'tarbak_tgz', _BACKUP_TARBAK_COMPRESS, 1);
//	$gui->add("form_text","", 'The auto-installer package will allow auto-extraction of the tarball archive' );
//	$gui->add("form_boolean", 'tarbak_inst', 'Create auto-installer', 0);
	global $d_db;
/*	if ($d_db == 'gladius') {
		$gui->add("form_text","", 'Your Gladius database files will be backed up as normal files');
	} else */{
		$gui->add("form_text","", _BACKUP_TARBAK_FF);
		$gui->add("form_boolean", 'tarbak_sql', _BACKUP_TARBAK_SQL, (int)($d_db != 'gladius' && $d_db!='sqlite'));
	}
	$gui->add("form_hidden", "step","", 1);

	$button_arr = array(array('name'=> _CONTINUE , 'onclick'=>'javascript:document.adminform.submit()'));
	$gui->add("bar");
	$gui->add("form_buttons","","",$button_arr);

	break;
	case 1:
	global $d_root;

	// in case of timeout before step 2 we reset and force the script to try again

	$tarbak_sql = in_num('tarbak_sql', $_POST, 0);

	if ($tarbak_sql) {
		include $d_root.'admin/classes/dbbackup.php';
		$dbbak = new DbBackup();
		$chosen = $dbbak->Snapshot();
	}

	// fallthrough allowed
	case 2:

	global $tarbak_dl, $tarbak_tgz;//, $tarbak_inst;
	$tarbak_dl = in_num('tarbak_dl', $_POST, 0);
	$tarbak_tgz = in_num('tarbak_tgz', $_POST, 0);
//	$tarbak_inst = in_num('tarbak_inst', $_POST, 0);

	$gui->add("tab_head");
	$gui->add("tab_simple","", _BACKUP_TARBAK_ARCHIVING);
	global $d_root;

	include $d_root.'admin/classes/TarBackup.php';

//	if ($tarbak_inst)	$skip[] = 'admin/classes/pcl/';
	global $tar, $skip_folders,$d_private,$d_rand;

//	$_SESSION[$d_rand.'tarbackup'] = null;
	
	$tar = new TarBackup($_SESSION[$d_rand.'tarbackup']);

	if ($step == 1) {
		$tar->BeginCreation($d_root, $d_root.$d_private.'backup/'.random_string(7).'_'.get_domain().'.'.( $tarbak_tgz ? 'tar.gz' : 'tar'), $skip_folders);

		if ($tarbak_sql)
			//FIXME: a duplicate of the sql is currently created...why? - to be verified
			$tar->AddFile($chosen);

	} else if (!isset($tar->progress)) {
			echo 'TarBackup: session data lost, please restart';
			return;
	}

	if (!$tar->CreateBackup('continue_cb', $GLOBALS['page_start_time'] - mt_float() ))
		die($tar->errstr);

	break;
	}

$gui->add("tab_tail");
$gui->add("end_form");
$gui->generate();

}

?>