<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Admin language component
# @author ?
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# html generation functions
#

function language_table() {
	global $d_root;
	$gui=new ScriptedUI();
	$gui->add("form","adminform","","admin.php?com_option=language");
	global $d_subpath;
	$gui->add('form_text', '',
		'<a href="http://wiki.drakecms.org/index.php?title=Tutorial:Translating_to_a_new_language" target="_blank"><img src="'.
		$d_subpath.'admin/templates/default/images/iana.png" border="0" />&nbsp;'.
		_LANG_TRANSLATE_INFO.'</a>');
	$gui->add("bar");
	$gui->add("com_header",_AMENU_MYSITE_LMANAGE);

	$table_head = array ( array('title'=>'radio' , 'val'=>'id' , 'len'=>'1%') ,
						  array('title'=>_LANG,'val'=>'name','len'=>'60%','info'=>_INFO,'ilink'=>'admin.php?com_option=language&task=info&cid[]=ivar1','ivar1'=>'id') ,
						  array('title'=>_LANG_CC,'val'=>'id','len'=>'10%') ,
						  array('title'=>_AUTHOR,'val'=>'author','len'=>'10%','mlink'=>'authorEmail') ,
						  array('title'=>_VER,'val'=>'version','len'=>'9%','align'=>'center') ,
						  array('title'=>_DATE,'val'=>'date','len'=>'10%','align'=>'center') ,
						 );
	$table_req = array ( 'name'=>'name','author'=>'author','version'=>'version','date'=>'creationDate','authorEmail'=>'authorEmail');
	$table_data = read_dir_xml($d_root."lang/",'',$table_req, 'languages/language');
	$gui->add("data_table_arr","maintable",$table_head,$table_data);
	$gui->add("end_form");
	$gui->generate();
}

function la_load_def(&$pool, $fname, &$missing) {
	global $total;
	$defines = array();
	
	$rd = file_get_contents($fname);
	$c = preg_match_all("/define\\s*\(\\s*('|\")([A-Z_0-9]+)('|\")/i", $rd, $original);
	$original = $original[2];
	
	if (preg_match_all("/define\\s*\(\\s*('|\")([A-Z_0-9]+)('|\")\\s*,".
						"\\s*('|\")(.*)('|\")".
						"\\s*\);/iU", $rd, $m)) {
		foreach($m[2] as $k) {
			$defines[$k] = str_decode(current($m[5]));
/*			if (strpos($defines[$k], '<')!==false) {
				echo 'HTML found in resource '.$k.'<br />';
			}	*/
			next($m[5]);
			
			if (isset($pool)) {
				if (isset($pool[$k])) {
					//trigger_error('Duplicate language resource identifier '.$k.' declared in '.$fname);
				} else { // add definition to the pool
					$pool[$k] =& $defines[$k];
				}
			}
		}
	}
	
	if (count($defines)!=$c) {
//		trigger_error(sprintf('Original resource has %d resources but %d have been parsed', $c, count($defines)));
		foreach($original as $mdef) {
			if (!isset($defines[$mdef])) {
				// try to get the definition from the pool
				if (isset($pool) && isset($pool[$mdef]))
					$defines[$mdef] = $pool[$mdef];
				else {
					if (isset($missing))
						$missing[]=$mdef;					
					else
						$defines[$mdef] = '(!) '.$mdef.' (!)';
				}
			}
		}		
	}
	return $defines;
}

function parse_definitions(&$gui, $root, $filename, $id) {

	$n = null;
	$defines = la_load_def($n, $root.$filename, $n = null);
	if (empty($defines))
		return;

	$gui->add("tab",$filename,_LANG_RESOURCES,"dtab");
	$gui->add('form_text', '', '<big>'.count($defines).'</big> resources on this tab');
	$gui->add('bar');
	foreach($defines as $define => $value) {
		if (strlen($value)>150)
			$big='_big';
		else $big='';
		$gui->add('form_textarea'.$big, 'lr'.$id.':'.$define, $define, $value);
	}

	$gui->add("tab_end");
}

include $d_root.'includes/glob.php';

function parse_lang_xml($lang, &$name, $extra=false) {
	global $d_root;

	$xml_files = safe_glob($d_root.'lang/'.$lang.'/*.xml');
	if (empty($xml_files)) {
		echo 'No XML file found';
		return false;
	}
	$xml = new AnyXML();
	$xml->fromString(file_get_contents($xml_files[0]));
	if (!isset($xml)) {
		echo 'Error reading XML file';
		return false;
	}
	
	$xml = $xml->getElementByPath('languages/language');
	if (!$xml || !($files =& $xml->getElementByPath('files'))) {
		echo 'Invalid XML file';
		return false;
	}
	
	$e = $xml->getElementByPath('name');
	$name = $e->getValue();
	if ($extra) {
		$e = $xml->getElementByPath('version');
		$ver = $e->getValue();
		$e = $xml->getElementByPath('author');
		$author = $e->getValue();
		$e = $xml->getElementByPath('authorEmail');
		$authorEmail = $e->getValue();
		$name = array($name, $ver, $author, $authorEmail, basename($xml_files[0]));
	}
	
	$childs =& $files->getAllChildren();
	$files = array();
	while ($child = current($childs)) {
		$file = $child->getValue();
		if (strtolower(substr($file, -4)) == '.php')
			$files[] = $file;
		next($childs);
	}
	return $files;
}

function edit_language($lang) {
	global $d_root;

	$files = parse_lang_xml($lang, $lang_name);
	if (!$files)
		return;

	$gui=new ScriptedUI();
	$gui->add("form","adminform","","admin.php?com_option=language");
	$gui->add("bar");
	$gui->add("com_header",_LANG_EDIT_HEAD.' "'.$lang_name.'"');
	
	$gui->add("tab_combo_link","dtab");
	$gui->add("tab_head");
	
	for ($id=0;$id<count($files);$id++) {
		parse_definitions($gui, $d_root.'lang/'.$lang.'/', $files[$id], $id);
	}

//	$rwlang = sprintf(_LANG_EDIT_STATUS,$lang_file,(is__writable($lang_file) ? _WRITE:_NWRITE));

	$gui->add("tab_tail");
	$gui->add("form_hidden","tab_num","",'');
	$gui->add("form_hidden","lang",'',$lang);
	$gui->add("tab_combo_sel","dtab","","1");

	$gui->add("end_form");

	$gui->generate();
}

function info_language($lang)
{
	global $d_root;

	$files = safe_glob($d_root.'lang/'.$lang.'/*.xml');
	if (empty($files)) {
		echo 'No XML file found';
		return;
	}
	$xml_file = $files[0]; unset($files);
	$table_req = array ( 'name'=>'name','author'=>'author','version'=>'version','date'=>'creationDate','authorEmail'=>'authorEmail');
	if(!($info=read_file_xml($xml_file,$table_req,'languages/language'))) {
		echo _LANG_INFO_ERROR;
		return;
	}
	$gui=new ScriptedUI();
	$gui->add("form","adminform","","admin.php?com_option=language");
	$gui->add("bar");
	$gui->add("com_header",_LANG_INFO_HEAD);
	$gui->add("tab_head");
	$gui->add("tab_simple","",_LANG_INFO_HEAD,"");
	$gui->add("form_text","",_LANG,$info['name']);
	$gui->add("form_text","",_AUTHOR,$info['author']." (<a href=\"mailto:".$info['authorEmail']."\">".$info['authorEmail']."</a>)");
	$gui->add("form_text","",_VER,$info['version']);
	$gui->add("form_text","",_CDATE,$info['date']);
	$gui->add("tab_end");
	$gui->add("tab_tail");
	$gui->add("end_form");
	$gui->generate();
}

function new_language($lang) {
	global $d_root;
	require_once $d_root.'includes/languages.php';
	$gui=new ScriptedUI();
	$gui->add("form","adminform","","admin.php?com_option=language");
	$gui->add("bar");
	$gui->add("com_header",_LANG_CREATE);
	$gui->add("tab_head");
	$gui->add("tab_simple","",_LANG_INFO_HEAD,"");
	$gui->add("form_text","",sprintf(_LANG_INFO_CLONE, '<strong>'.strtoupper($lang).'</strong>'),"");
	$gui->add("bar");

	$cc_drop=select($cc, $lang);
	$gui->add("form_select","lang_cc",_LANG_CC,$cc_drop,"",'!fi_val');
	$gui->add("form_text","",_LANG_INFO_CC."<a target=\"_blank\" href=\"http://www.iso.org/iso/en/prods-services/iso3166ma/02iso-3166-code-lists/list-en1.html\">ISO 3166</a>");
	$gui->add("bar");
	$gui->add("form_textfield","lang_name",_NAME,'','','!fi_val');
	$gui->add("form_textfield","lang_version",_LANG_VERSION,'0.1');
	$gui->add("form_textfield","lang_author",_AUTHOR,'','','!fi_val');
	$gui->add("form_textfield","lang_email",_EMAIL);
	
	$gui->add("form_hidden","lang_base",'',$lang);
	$gui->add("tab_end");
	$gui->add("tab_tail");
	$gui->add("end_form");
	$gui->generate();
}

function save_defines($fname, &$defines) {
	$f = fopen($fname, 'w');
	fwrite($f, '<?'.'php'."\r\n");
	foreach($defines as $dk => $val) {
		// there is no need to apply htmlentities or htmlspecialchars as the input has not yet been touched by browsers
		$fixed = preg_replace('/(\r\n)|(\r)|(\n)/', '\\n', str_replace('"', '\\"', $val));
		fwrite($f, 'define(\''.$dk.'\', "'.$fixed.'");'."\n");
	}
	fwrite($f, '?>');
	fclose($f);
}

function write_language_descriptor($lang_cc, $lang_name, $lang_version, $lang_author, $lang_email, $lang_fname) {
	global $d_root;
	
	$lang_name = html_entity_decode($lang_name);
	$lang_author = html_entity_decode($lang_author);
		$raw_xml = '<?xml version="1.0" encoding="iso-8859-1"?>
<dkinstall version="0.2">
	<languages>
		<language>
			<id>'.$lang_cc.'</id>
			<name>'.$lang_name.'</name>
			<version>'.$lang_version.'</version>
			<creationDate>'.date('Y/m/d').'</creationDate>
			<author>'.$lang_author.'</author>
			<authorEmail>'.$lang_email.'</authorEmail>
			<files>';
		$f=fopen($d_root.'lang/'.$lang_cc.'/'.$lang_fname,'w');
		fwrite($f,$raw_xml);
		parsefiles($d_root.'lang/'.$lang_cc.'/', '', $f);
		fwrite($f, '</files>
		</language>
	</languages>
</dkinstall>');
		fclose($f);
}

function repair_language($lang) {
	$en_files = parse_lang_xml('en', $lang_name);
	if (!$en_files)
		return sprintf(_LANG_CANNOT_FIND, 'EN');
	
	$files = parse_lang_xml($lang, $xml_info, true);
	if (!$files)
		return sprintf(_LANG_CANNOT_FIND, strtoupper($lang));
		
	global $d_root;
	$msg='';
	
	$xml_upd = false;
	
	include $d_root.'admin/classes/fs.php';
	$fs = new FS();
	
	$fkeys=array_flip($files);
	foreach ($files as $file) {
		if (!in_array($file, $en_files)) {
			$fs->unlink($d_root.'lang/'.$lang.'/'.$file);
			$msg.='\\n'.$file.' '._LANG_REMOVED;
			unset($files[$fkeys[$file]]);
			$xml_upd = true;
		}
	}
	unset($fkeys);

	// the swimming pool of all resources
//	$pool = array();
	$pool = null;
	$n = null;

	foreach ($en_files as $file) {
		$dest = $d_root.'lang/'.$lang.'/'.$file;
		if (!in_array($file, $files) || !file_exists($dest)) {
			copy($d_root.'lang/en/'.$file, $dest);
			$msg.='\\n'.$file.' '._LANG_ADDED;
			$xml_upd = true;
			continue;
		}
		$en_defines = la_load_def($n, $d_root.'lang/en/'.$file, $n);
		if (!count($en_defines))
			continue;
		$defines = la_load_def($pool, $dest, $missing = array());
		$added = 0;
		if (count($missing)) {
			foreach ($missing as $mdef) {
				if (isset($en_defines[$mdef])) {
					$defines[$mdef] = $en_defines[$mdef];
					++$added;
				}
			}
			unset($missing);
		}
		$en_dkeys = array_keys($en_defines);
		$dkeys = array_keys($defines);
		foreach($en_dkeys as $dk) {
			if (!in_array($dk, $dkeys)) {
				// try to get the definition from the pool
				if (isset($pool[$dk]))
					$defines[$dk] = $pool[$dk];
				else
					$defines[$dk] = $en_defines[$dk];
				++$added;
			}
		}
		$removed = 0;
		foreach($dkeys as $dk) {
			if (!in_array($dk, $en_dkeys)) {
				unset($defines[$dk]);
				++$removed;
			}
		}
		if ($added || $removed) {
			save_defines($d_root.'lang/'.$lang.'/'.$file, $defines);
			if ($added)
				$msg.='\\n'.$file.':'.$added.' '._LANG_RESOURCES_ADDED;
			if ($removed)
				$msg.='\\n'.$file.':'.$removed.' '._LANG_RESOURCES_REMOVED;
		}
		
	}
	
	unset($pool);
	
	if ($msg=='')
		return _LANG_UP_TO_DATE;

	if ($xml_upd)
		write_language_descriptor($lang, $xml_info[0], $xml_info[1], $xml_info[2], $xml_info[3], $xml_info[4]);
	
	return $msg.'\\n\\n'._LANG_REPAIRED;
}

?>