<?php
if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Subsites component for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# HTML output functions
#

function get_subsite_attributes($subpath) {
	global $d_root,$d_private;
	$cfg = $d_root.$subpath.$d_private.'config.php';
	if (!file_exists($cfg)) {
		$row['title'] = '<i>'._SUBSITES_NA.'</i>';
		$row['status'] = 2;
	} else {
		$cfg = file_get_contents($cfg);
		preg_match('/d_title='.__QUOTED_S.';/', $cfg, $m);
		$row['title'] = stripslashes(substr($m[1], 1, -1));
		preg_match('/d_online='.__QUOTED_S.';/', $cfg, $m);
		$row['status'] = (int)$m[1]{1};
		unset($cfg);
	}
	return $row;
}

function subsites_table() {
	global $conn;
	$gui=new ScriptedUI();
	$gui->add("form","adminform","","admin.php?com_option=subsites");
	$gui->add("com_header",_AMENU_SUBSITES);
	$table_head = array ( array('title'=>'#' , 'val'=>'id' , 'len'=>'1%','align'=>'center') ,
						  array('title'=>'checkbox' , 'val'=>'id' , 'len'=>'1%','align'=>'center') ,
						  array('title'=>_SUBSITES_SUBPATH,'val'=>'subpath','len'=>'44%') ,
						  array('title'=>_TITLE,'val'=>'title','len'=>'44%') ,
						  array('title'=>_SUBSITES_STATUS,'val'=>'status','len'=>'10%','align'=>'center')
						 );
	$rs=$conn->Execute('SELECT id, subpath FROM #__subsites');
	$table_data=array();
	$status = array(_SUBSITES_OFFLINE, _SUBSITES_ONLINE, '<i>'._SUBSITES_INVALID_PATH.'</i>');
	while ($row = $rs->GetArray(1)) {
		$row = $row[0];
		$a = get_subsite_attributes($row['subpath']);
		$row['title'] = $a['title'];
		$row['status'] = $status[$a['status']];
		$table_data[] = $row;
	}

	$gui->add("data_table_arr","maintable",$table_head,$table_data);
	$gui->add("end_form");
	$gui->generate();
}

function subsite_edit($clone, $task)
{
	global $conn,$d_root;
	$gui=new ScriptedUI();
	$gui->add("form","adminform","","admin.php?com_option=subsites");
	if ($task == 'create')
		$head = _SUBSITES_NEW;
	else
		$head = _SUBSITES_EDIT;
	$gui->add("com_header",$head);
	$gui->add("tab_head");
	$gui->add("tab_simple","",$head,"");

	if ($clone != 0) {
		$row=$conn->GetArray("SELECT subpath FROM #__subsites WHERE id=".$clone);
		$subpath = $row[0]['subpath'];
	} else
		$subpath = '';
	$gui->add("form_text",'',sprintf(_SUBSITES_CLONE, (($clone == 0) ? _SUBSITES_ROOT : _SUBSITES_SUBSITE),
									'<strong>/'.$subpath.'</strong>').'<hr />'._SUBSITES_REMEMBER);
	$gui->add("form_textfield","subsite_path",_SUBSITES_SUBPATH,  $subpath, '', '!fi_val');
	if ($task == 'save') {
		$gui->add("form_hidden",'p_subpath',"",$subpath);
		$gui->add("form_hidden",'id',"",$clone);
	} else
		$gui->add("form_hidden",'src',"",$subpath);

	$gui->add("form_hidden",'task',"",$task);
	$gui->add("tab_end");
	$gui->add("tab_tail");
	$gui->add("end_form");
	$gui->generate();
}

?>