<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Subsites component for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# main subsites management script
#

include com_path($d_type);

function subsite_publication($online) {
	global $d_root, $d, $conn;
	$ids = in('cid', __ARR | __NUM, $_POST);
	foreach ($ids as $id) {
		$r = $conn->GetRow('SELECT subpath FROM #__subsites WHERE id = '.$id);
		$cfg = $d_root.$r['subpath'].$d_private;
		$configArr = $d->_getConfig($cfg);
		$configArr['d_online'] = $online;
		$d->_setConfig($cfg, $configArr);
	}
}

switch ($task) {
	case 'new':
		$clone = in('cid', __ARR0 | __NUM, $_POST, 0);
		subsite_edit($clone, 'create');
	break;
	case 'edit':
		if (null !== ($id = in('cid', __ARR0 | __NUM, $_POST)))
			subsite_edit($id, 'save');
	break;
	case 'save':
		if ( (null === ($id = in_num('id', $_POST))) ||
			('' === ($subpath = in_sql('subsite_path', $_POST, ''))) ||
			('' === ($p_subpath = in_sql('p_subpath', $_POST, '')))
		)
			$d->Redir('admin.php?com_option=subsites', _FORM_NC);

		if ($subpath{strlen($subpath)-1}!='/')
			$subpath.='/';

		if ($subpath != $p_subpath) {
			if (is_dir($d_root.$p_subpath))
				rename($d_root.$p_subpath, $d_root.$subpath);
			$conn->Execute('UPDATE #__subsites SET subpath = \''.$subpath.'\' WHERE id = '.$id);
			$msg = 'Changes succesfully applied';
		} else
			$msg = '';
		$d->Redir('admin.php?com_option=subsites', $msg);
	break;
	case 'create':
	
		include $d_root.'admin/classes/fs.php';
		$fs = new FS();

	
		//TODO: copy also the index.htm files
		if ( (null === ($clone_src = in_sql('src', $_POST))) ||
			('' === ($subpath = in_sql('subsite_path', $_POST, ''))) )
			$d->Redir('admin.php?com_option=subsites', _FORM_NC);

		if ($subpath{strlen($subpath)-1}!='/')
			$subpath.='/';

		if (is_dir($d_root.$subpath))
			$d->Back(_SUBSITES_DIR_EXISTS);

		// create the subsite folders structure
		$subfolders = array ('',
							substr($d_private, 0, strlen($d_private)-1),
							$d_private.$d_dbname,
							$d_private.'uploads',
							$d_private.'cache',
							$d_private.'backup',
							'images',
							'images/banners',
							'images/icons',
							'images/gallery',
							'images/gallery/thumbs'
						);
		foreach ($subfolders as $dir) {
			$fs->mkdir($d_root.$subpath.$dir);
		}

		// create the subsite config.php file
		$configArr = $d->_getConfig($d_root.$clone_src.$d_private);
		$configArr['d_online'] = 0;
		$configArr['d_title'] .= ' subsite';
		$configArr['d_website'] .= $subpath;
		$newrand = random_string(7);
		$configArr['d_rand'] = $newrand;

		if ($d_db=='gladius') { // plain copy for flatfile databases
			$fs->fcopy($d_root.$clone_src.$d_private.$d_dbname.'/',
							  $d_root.$subpath.$d_private.$d_dbname.'/');
		} else if ($d_db=='sqlite') {
			$fs->copy($d_root.$d_private.$d_dbname.'/'.$d_rand.'_'.$d_dbname.'.db',
					$d_root.$subpath.$d_private.$d_dbname.'/'.$newrand.'_'.$d_dbname.'.db');
		} else {
			preg_match('/\\d+/', $d_prefix, $m);
			if (empty($m))	$n = 0;
			else			$n = (int)$m[0];
			$n += mt_rand(1, 99-$n);
			$configArr['d_prefix'] = substr($d_prefix, 0, -1).(string)$n.'_';

			include $d_root.'admin/classes/dbbackup.php';
			$dbbak = new DbBackup();
			$newconn = new DbFork($d_db, $d_dbhost,$d_dbusername,$d_dbpassword,$d_dbname, $configArr['d_prefix']);
			$dbbak->Replicate($newconn);
		}
		$d->_setConfig($d_root.$subpath.$d_private, $configArr);
		unset($configArr);
		
		$fs->fcopy($d_root.$clone_src.'images/', $d_root.$subpath.'images/');
		$fs->fcopy($d_root.$clone_src.'images/icons/', $d_root.$subpath.'images/icons/');
		$fs->fcopy($d_root.$clone_src.'images/banners/', $d_root.$subpath.'images/banners/');
		$fs->tcopy($d_root.$clone_src.'images/gallery/', $d_root.$subpath.'images/gallery/');
		$fs->tcopy($d_root.$clone_src.'images/gallery/thumbs/', $d_root.$subpath.'images/gallery/thumbs/');
		$fs->copy($d_root.$clone_src.'404.php', $d_root.$subpath.'404.php');

		$conn->Execute('INSERT INTO #__subsites (subpath) VALUES( \''.$subpath.'\')');

		$pages = array('index.php', 'index2.php', 'admin.php', 'admin2.php', 'version.php');
		if ($clone_src !== '') {
			foreach ($pages as $page)
				$fs->copy($d_root.$clone_src.$page, $d_root.$subpath.$page);
		} else {
			foreach ($pages as $page) {
				$content = '<'."?php ## Subsite proxy for $page\n\n\$d_subpath = '../';\n\n\$d_private = '{$subpath}$d_private';\n\ninclude '../$page';\n\n?".'>';
				$f = fopen($d_root.$subpath.$page,'w');
				fwrite($f, $content);
				fclose($f);
				unset($content);
			}
		}
		
		// setup the admin login
		global $d_rand;
		$_SESSION[$newrand.'uid'] = $_SESSION[$d_rand.'uid'];

		$d->Redir($subpath.'admin.php?com_option=config');
	break;
	case 'delete':
		$ids = in('cid', __ARR | __NUM, $_POST);
		include $d_root.'admin/classes/fs.php';
		$fs = new FS();

		foreach ($ids as $id) {
			$row = $conn->GetArray('SELECT subpath FROM #__subsites WHERE id='.$id);
			$dir = $d_root.$row[0]['subpath'];
			if (is_dir($dir))
				$fs->deldir($dir);
			$conn->Execute('DELETE FROM #__subsites WHERE id='.$id);
		}
		$d->Redir('admin.php?com_option=subsites');
	break;
	case 'publish':
		subsite_publication(1);
		$d->Redir('admin.php?com_option=subsites');
	break;
	case 'unpublish':
		subsite_publication(0);
		$d->Redir('admin.php?com_option=subsites');
	break;
	default:
		subsites_table();
}

?>