/* @DKPDL 0.3 @GID  5 <?php if (@$my->gid< 5)die; ?> */

DROP TABLE #__banners;

CREATE TABLE #__banners (
id INTEGER AUTO_INCREMENT,
name VARCHAR(50) NOT NULL,
imp INTEGER NOT NULL DEFAULT 0,
imphits INTEGER NOT NULL DEFAULT 0,
hits INTEGER NOT NULL DEFAULT 0,
imageurl TEXT NOT NULL,
clickurl TEXT NOT NULL,
published INTEGER NOT NULL DEFAULT 0,
bannercode TEXT,
PRIMARY KEY (id) 
);

DROP TABLE #__categories;

CREATE TABLE #__categories (
id INTEGER AUTO_INCREMENT,
parent_id INTEGER NOT NULL DEFAULT 0,
title VARCHAR(50) NOT NULL,
name VARCHAR(255) NOT NULL,
image VARCHAR(255) NOT NULL DEFAULT '',
image_position VARCHAR(10) NOT NULL DEFAULT 'left',
section VARCHAR(20) NOT NULL,
description TEXT,
ordering INTEGER NOT NULL DEFAULT 0,
access INTEGER NOT NULL DEFAULT 9,
count INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__components;

CREATE TABLE #__components (
id INTEGER AUTO_INCREMENT,
name VARCHAR(50) NOT NULL,
link TEXT NOT NULL,
menuid INTEGER NOT NULL DEFAULT 0,
parent INTEGER NOT NULL DEFAULT 0,
admin_menu_link TEXT NOT NULL,
admin_menu_alt VARCHAR(255) NOT NULL,
option_link TEXT NOT NULL,
ordering INTEGER NOT NULL DEFAULT 0,
iscore INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__forum_categories;

CREATE TABLE #__forum_categories (
id INTEGER AUTO_INCREMENT,
parent_id INTEGER NOT NULL DEFAULT 0,
name VARCHAR(255) NOT NULL,
description TEXT,
locked INTEGER NOT NULL DEFAULT 0,
moderators VARCHAR(255) NOT NULL,
ordering INTEGER NOT NULL DEFAULT 0,
access INTEGER NOT NULL DEFAULT 9,
editgroup INTEGER NOT NULL DEFAULT 0,
checked_out INTEGER NOT NULL DEFAULT 0,
topic_count INTEGER NOT NULL DEFAULT 0,
post_count INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__forum_config;

CREATE TABLE #__forum_config (
id INTEGER AUTO_INCREMENT,
rep_word VARCHAR(255) NOT NULL DEFAULT '',
bad_words TEXT NOT NULL DEFAULT '',
show_count INTEGER NOT NULL DEFAULT 10,
PRIMARY KEY (id) 
);

DROP TABLE #__forum_posts;

CREATE TABLE #__forum_posts (
id INTEGER AUTO_INCREMENT,
thread_id INTEGER NOT NULL DEFAULT 0,
parent_id INTEGER NOT NULL DEFAULT 0,
catid INTEGER NOT NULL DEFAULT 0,
name VARCHAR(100) NOT NULL,
userid INTEGER NOT NULL DEFAULT 0,
subject VARCHAR(255) NOT NULL,
message TEXT,
time VARCHAR(20) NOT NULL,
ip VARCHAR(36) NOT NULL,
PRIMARY KEY (id) 
);

DROP TABLE #__forum_topics;

CREATE TABLE #__forum_topics (
id INTEGER AUTO_INCREMENT,
catid INTEGER NOT NULL DEFAULT 0,
name VARCHAR(50) NOT NULL,
userid INTEGER NOT NULL DEFAULT 0,
subject VARCHAR(255) NOT NULL,
time VARCHAR(20) NOT NULL,
locked INTEGER NOT NULL DEFAULT 0,
sticked INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
checked_out INTEGER NOT NULL DEFAULT 0,
post_count INTEGER NOT NULL DEFAULT 0,
post_list TEXT,
hits INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__forum_notifies;

CREATE TABLE #__forum_notifies (
topic_id INTEGER NOT NULL,
user_id INTEGER NOT NULL
);

DROP TABLE #__forum_users;

CREATE TABLE #__forum_users (
id INTEGER AUTO_INCREMENT,
posts INTEGER NOT NULL DEFAULT 0,
image VARCHAR(255) NOT NULL DEFAULT '',
location VARCHAR(100) NOT NULL DEFAULT '',
signature VARCHAR(255) NOT NULL DEFAULT '',
information TEXT NOT NULL DEFAULT '', 
url VARCHAR(100) NOT NULL DEFAULT '',
PRIMARY KEY (id) 
);

DROP TABLE #__content;

CREATE TABLE #__content (
id INTEGER AUTO_INCREMENT,
title VARCHAR(100) NOT NULL,
title_alias VARCHAR(100) NOT NULL,
introtext TEXT,
bodytext TEXT,
sectionid INTEGER NOT NULL DEFAULT 0,
mask INTEGER NOT NULL DEFAULT 0,
catid INTEGER NOT NULL DEFAULT 0,
created INTEGER NOT NULL,
modified INTEGER NOT NULL,
created_by INTEGER NOT NULL DEFAULT 0,
created_by_alias VARCHAR(100) NOT NULL,
published INTEGER NOT NULL DEFAULT 0,
frontpage INTEGER NOT NULL DEFAULT 0,
ordering INTEGER,
metakey TEXT,
metadesc TEXT,
access INTEGER NOT NULL DEFAULT 0,
hits INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__content_comment;

CREATE TABLE #__content_comment (
id INTEGER AUTO_INCREMENT,
comment_id INTEGER NOT NULL DEFAULT 0,
title CHAR(255) NOT NULL,
name CHAR(50) NOT NULL,
comment CHAR(255) NOT NULL,
date INTEGER NOT NULL,
PRIMARY KEY (id) 
);

DROP TABLE #__content_frontpage;

CREATE TABLE #__content_frontpage (
id INTEGER NOT NULL,
ordering INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__content_rating;

CREATE TABLE #__content_rating (
id INTEGER AUTO_INCREMENT,
rating_sum INTEGER NOT NULL DEFAULT 0,
rating_count INTEGER NOT NULL DEFAULT 0,
lastip VARCHAR(36) NOT NULL,
PRIMARY KEY (id) 
);

DROP TABLE #__downloads;

CREATE TABLE #__downloads (
id INTEGER AUTO_INCREMENT,
catid INTEGER NOT NULL DEFAULT 0,
title VARCHAR(50) NOT NULL,
url TEXT NOT NULL,
image_url TEXT NOT NULL,
website TEXT NOT NULL,
description TEXT,
filesize INTEGER NOT NULL,
add_date INTEGER NOT NULL,
mod_date INTEGER NOT NULL,
down_date INTEGER NOT NULL DEFAULT 0,
hits INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
approved INTEGER NOT NULL DEFAULT 0,
access INTEGER NOT NULL DEFAULT 9,
author VARCHAR(100) NOT NULL,
PRIMARY KEY (id) 
);

DROP TABLE #__drabots;

CREATE TABLE #__drabots (
id INTEGER AUTO_INCREMENT,
name VARCHAR(100) NOT NULL,
type VARCHAR(30) NOT NULL,
element VARCHAR(100) NOT NULL,
showon VARCHAR(255) NOT NULL,
access INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
published INTEGER NOT NULL DEFAULT 0,
iscore INTEGER NOT NULL DEFAULT 0,
params TEXT,
PRIMARY KEY (id) 
);

DROP TABLE #__event;

CREATE TABLE #__event (
id INTEGER AUTO_INCREMENT,
title VARCHAR(255) NOT NULL,
description TEXT,
sdate INTEGER NOT NULL DEFAULT 0,
edate INTEGER NOT NULL DEFAULT 0,
published INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__faq;

CREATE TABLE #__faq (
id INTEGER AUTO_INCREMENT,
catid INTEGER NOT NULL DEFAULT 0,
question TEXT,
answer TEXT,
published INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__gallery;

CREATE TABLE #__gallery (
id INTEGER AUTO_INCREMENT,
catid INTEGER NOT NULL DEFAULT 0,
title VARCHAR(50) NOT NULL,
description TEXT,
url TEXT NOT NULL,
date INTEGER NOT NULL,
hits INTEGER NOT NULL DEFAULT 0,
published INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__guestbook;

CREATE TABLE #__guestbook (
id INTEGER AUTO_INCREMENT,
name VARCHAR(50) NOT NULL,
email VARCHAR(50) NOT NULL,
url TEXT NOT NULL,
country VARCHAR(50) NOT NULL,
title VARCHAR(255) NOT NULL,
message TEXT,
reply TEXT,
ip VARCHAR(36) NOT NULL,
date INTEGER NOT NULL,
PRIMARY KEY (id) 
);

DROP TABLE #__menu;

CREATE TABLE #__menu (
id INTEGER AUTO_INCREMENT,
menutype VARCHAR(25) NOT NULL,
name VARCHAR(100) NOT NULL,
link TEXT,
link_type VARCHAR(50) NOT NULL,
parent INTEGER NOT NULL DEFAULT 0,
componentid INTEGER NOT NULL DEFAULT 0,
sublevel INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
browsernav INTEGER NOT NULL DEFAULT 0,
access INTEGER NOT NULL DEFAULT 9,
params TEXT,
PRIMARY KEY (id) 
);

DROP TABLE #__messages;

CREATE TABLE #__messages (
id INTEGER AUTO_INCREMENT,
name VARCHAR(50) NOT NULL,
email VARCHAR(50) NOT NULL,
message_subject VARCHAR(255),
message_text TEXT,
date INTEGER NOT NULL,
status INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__modules;

CREATE TABLE #__modules (
id INTEGER AUTO_INCREMENT,
title TEXT,
message TEXT,
ordering INTEGER NOT NULL DEFAULT 0,
position VARCHAR(10) NOT NULL,
published INTEGER NOT NULL DEFAULT 0,
module VARCHAR(50) NOT NULL,
numnews INTEGER NOT NULL DEFAULT 0,
access INTEGER NOT NULL DEFAULT 0,
showtitle INTEGER NOT NULL DEFAULT 1,
showon TEXT,
params TEXT,
iscore INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__newsflash;

CREATE TABLE #__newsflash (
id INTEGER AUTO_INCREMENT,
title VARCHAR(50) NOT NULL,
news TEXT,
access INTEGER NOT NULL DEFAULT 9,
PRIMARY KEY (id) 
);

DROP TABLE #__polls_data;

CREATE TABLE #__polls_data (
id INTEGER AUTO_INCREMENT,
pollid INTEGER NOT NULL DEFAULT 0,
polloption VARCHAR(255) NOT NULL,
hits INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__polls_votes;

CREATE TABLE #__polls_votes (
id INTEGER AUTO_INCREMENT,
ip VARCHAR(36) NOT NULL,
pollid INTEGER NOT NULL DEFAULT 0,
date INTEGER NOT NULL,
PRIMARY KEY (id) 
);

DROP TABLE #__sections;

CREATE TABLE #__sections (
id INTEGER AUTO_INCREMENT,
title VARCHAR(50) NOT NULL,
name VARCHAR(255) NOT NULL,
image VARCHAR(100) NOT NULL,
image_position VARCHAR(10) NOT NULL,
description TEXT,
published INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
access INTEGER NOT NULL DEFAULT 0,
count INTEGER NOT NULL DEFAULT 0,
editgroup INTEGER NOT NULL DEFAULT 3,
PRIMARY KEY (id) 
);

DROP TABLE #__simple_stats;

CREATE TABLE #__simple_stats (
id INTEGER AUTO_INCREMENT,
ip VARCHAR(36) NOT NULL,
date INTEGER NOT NULL DEFAULT 0,
count INTEGER NOT NULL DEFAULT 0,
uid INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);

DROP TABLE #__subsites;

CREATE TABLE #__subsites (
id INTEGER AUTO_INCREMENT,
subpath VARCHAR(255),
PRIMARY KEY (id) 
);

DROP TABLE #__users;

CREATE TABLE #__users (
id INTEGER AUTO_INCREMENT,
name VARCHAR(50) NOT NULL,
username VARCHAR(25) NOT NULL,
email VARCHAR(100) NOT NULL,
password VARCHAR(100) NOT NULL,
published INTEGER NOT NULL DEFAULT 1,
gid INTEGER NOT NULL DEFAULT 1,
registerDate INTEGER NOT NULL,
lastvisitDate INTEGER NOT NULL,
lang VARCHAR(2) NOT NULL DEFAULT 'en',
PRIMARY KEY (id) 
);

DROP TABLE #__weblinks;

CREATE TABLE #__weblinks (
id INTEGER AUTO_INCREMENT,
catid INTEGER NOT NULL DEFAULT 0,
title VARCHAR(50) NOT NULL,
url TEXT NOT NULL,
description TEXT,
date INTEGER NOT NULL,
hits INTEGER NOT NULL DEFAULT 0,
published INTEGER NOT NULL DEFAULT 0,
ordering INTEGER NOT NULL DEFAULT 0,
PRIMARY KEY (id) 
);
