<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Database abstraction layer
#
# this class should abstract our custom options over adoDB, like db prefix, caching and others
#

class DbFork {
	var $adodb;
	var $prefix;
	var $connected;
	
	function _prefixReplace(&$sqlstring) {
		 $sqlstring = str_replace("#__", $this->prefix, $sqlstring);
	}
	
	function _db_name($db_type, $db_name) {
		if ($db_type=='sqlite') {
			global $d_root, $d_private, $d_rand;
			return $d_root.$d_private.$db_name.'/'.$d_rand.'_'.$db_name.'.db';
		}
		return $db_name;
	}

	function DbFork($db_type, $db_host, $db_user, $db_password, $db_name, $db_prefix) {
		if (defined('_VALID_ADMIN'))
			$this->adodb =& ADONewConnection($db_type, 'pear:meta');
		else
			$this->adodb =& ADONewConnection($db_type);
//		$this->adodb->debug = true;
		$this->prefix = $db_prefix;
		$this->connected = $this->adodb->PConnect($db_host,$db_user,$db_password, $this->_db_name($db_type, $db_name));
	}

	function Affected_Rows() {
		return $this->adodb->Affected_Rows();
	}

	function &GetRow($sql) {
		$this->_prefixReplace($sql);
		$rs =& $this->adodb->SelectLimit($sql, 1);
		$arr = $rs->GetArray(1);
		if (isset($arr[0]))
			return $arr[0];
		else
			return $arr;
	}

	function &GetArray($sql, $nrows = -1) {
		$this->_prefixReplace($sql);
		return $this->adodb->GetArray($sql, $nrows);
	}

	function Quote($s, $magic = false) {
		// eventual magic quotes slashes already stripped by in() function
		$qs = $this->adodb->qstr($s, $magic);
		return substr($qs, 1, strlen($qs)-2);
	}

	function Insert_ID() {
    	return $this->adodb->Insert_ID();
	}

	function Execute($sql) {
		$this->_prefixReplace($sql);
		return $this->adodb->Execute($sql);
	}
	
	function _sreplace($m) {
		switch($m[0]) {
			case '%s':
				return $this->adodb->qstr(next($this->_s_args), false);
			case '%n':
				// debug lines
				$v = next($this->_s_args);
				if (empty($v)) return '0';
				return $v;
			default:
				return "'".next($this->_s_args)."'";
		}
	}
	
	// first parameter is pattern, other parameters are variadic and referenced by
	// %n - numeric, no quotes
	// %q - quoted only (no sql_encode)
	// %s - quoted and made safe through sql_encode
	function SExecute() {
		$args = func_get_args();
		$this->_s_args =& $args;
		$sql = preg_replace_callback('/%n|%s|%q/', array($this, '_sreplace'), $args[0]);
		unset($this->_s_args);
		return $this->Execute($sql);		
	}

	function &SelectLimit($sql, $nrows, $offset = -1) {
		$sql = str_replace("#__", $this->prefix, $sql);
		return $this->adodb->SelectLimit($sql, $nrows, $offset);
	}

	function ErrorMsg() {
		return $this->adodb->ErrorMsg();
	}

	function EOF() {
		return $this->adodb->EOF();
	}

}

?>