<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## GeloMail class
# @author legolas558
#
# HTML and text emails generation

global $d_root;
include_once $d_root.'includes/download.php';

/*
if ( !function_exists('htmlspecialchars_decode') )
{
   function htmlspecialchars_decode($text)
   {
       return strtr($text, array_flip(get_html_translation_table(HTML_SPECIALCHARS)));
   }
}

   function utf8_replaceEntity($result){
   
       $value = (int)$result[1];
       $string = '';
      
       $len = round(pow($value,1/8));
      
       for($i=$len;$i>0;$i--){
           $part = ($value & (255>>2)) | pow(2,7);
           if ( $i == 1 ) $part |= 255<<(8-$len);
          
           $string = chr($part) . $string;
          
           $value >>= 6;
       }
      
       return $string;
   }
  
   function utf8_html_entity_decode($string){
       return preg_replace_callback(
           '/&#([0-9]+);/u',
           'utf8_replaceEntity',
           $string
       );
   }
   
function entity_decode($s) {
	return utf8_html_entity_decode(htmlspecialchars_decode($s));
} */

class GeloMail {
	var $bcc;
	var $html;
	var $attach; // {mime type, original filename, temporary (moved) filename}
	
	var $_domain;
	
	function GeloMail($html = false) {
		$this->bcc = array();
		$this->attach = null;
		$this->html = $html;
		$this->_domain = (string)@ini_get('sendmail_from');
		if (!isset($this->_domain[0]))
			$this->domain = get_domain(true);
		else
			$this->_domain = substr($this->_domain, strpos($this->_domain, '@')+1);
	}
	
	function admin_emails() {
		global $conn,$my;
		$rows=$conn->GetArray("SELECT email FROM #__users WHERE gid>3 AND published=1");
		if (!count($rows))
			return array();
		$bcc=array();
		foreach ($rows as $row) { // do not send email to the author
			if ($row['email'] != $my->email)
				$bcc[] = $row['email'];
		}
		return $bcc;
	}
	
	function _rfc2045_safe($data) {
		$p = strpos($data, "\n");
		if ($p!==false)
			$data = substr($data,0,$p);
		$p = strpos($data, "\r");
		if ($p!==false)
			$data = substr($data,0,$p);
		return $data;
	}
	
function _encode_header($string) {
       $len = strlen($string);
       $result = '';
	   $enc = false;
       for($i=0;$i<$len;++$i) {
		$c = $string[$i];
		if (ctype_alpha($c))
			$result.=$c;
		else if ($c==' ') {
			$result.='_';
			$enc = true;
		} else {
			$result.=sprintf("=%02X", ord($c));
			$enc = true;
		}
       }
	   if (!$enc) return $string;
	   global $d;
       return '=?'.strtoupper($d->Encoding()).'?q?'.$result.'?=';
}

// old B encoding
/*	$l=strlen($s);
		for ($i=0;$i<$l;++$i) {
			if (ord($s{$i})>127)
				return '='.strtoupper($d->Encoding()).'?B?'.base64_encode($s).'?=';
		}
		return $s; */

	function craft_headers($from_name,$from_email) {
		global $my,$d_website,$conn;
		//$headers = 'Received: from user'.$my->id.' ('.$my->GetIP().	') by '.$_SERVER["SERVER_NAME"].' via '.$d_website.$_SERVER['SCRIPT_NAME'].'; '.date('r')."\r\n";
		$from_name = $this->_rfc2045_safe($from_name);
		$from_email = $this->_rfc2045_safe($from_email);
		$headers = "From: ".$this->_encode_header($from_name)." <".$from_email.">\r\n";
		$c=count($this->bcc);
		if ($c) {	//L: needs testing, maybe we want separate Bcc headers for each email (more widely compatible)? RFC2045 will answer
			$headers.='Bcc: ';
			for($i=0;$i<$c-1;$i++)
				$headers .= $this->bcc[$i].', ';
			$headers .= $this->bcc[$c-1]."\r\n";
		}
		// only the first admin has the return-path set for him
		if ($my->id!==false) {	// only registered users can see the admin email address & username
			$ret_path = $conn->GetRow('SELECT username,email FROM #__users WHERE gid=5');
			$ret_name = $this->_encode_header($ret_path['username']);
			$ret_path = $ret_path['email'];
			$headers .= 'Reply-To: '.$ret_name.' <'.$ret_path.">\r\n";
			$headers .= 'Return-Path: '.$ret_name.' <'.$ret_path.">\r\n";
		}
		$headers .= "Message-ID: <".md5($my->id.time())."@".$this->_domain.">\r\n";
		if ($my->id!==false)
			$headers .= 'X-Authenticated: #'.((string)$my->id)."\r\n";
		//$headers .= "X-Priority: 3\r\nX-MSMail-Priority: Low\r\n";
		$headers .= 'X-Mailer: Drake v'.drake_version()."\r\n";
		$headers .= 'Date: '.date('r')."\r\n";	//L: will fix some servers bad behaviour
		return $headers;
	}
	
	function Send($recipient, $subject, $message, $from_email=null, $from_name=null) {
	
		if(empty($from_email)){	// should prevent previous version empty string'' version
			$from_name='Drake Robot';
			$from_email='robot@'.$this->_domain;
		} 
		//else $from_name = entity_decode($from_name);
		
//		$subject = entity_decode($subject);
		
		if (isset($this->attach)) {
			$boundary = '------------'.random_string(24);
			$intro = "This is a multi-part message in MIME format\r\n\r\n".
						'--'.$boundary."\r\n";
		} else $intro='';

		$headers = $this->craft_headers($from_name, $from_email);

		global $d;
		$ctype = 'Content-Type: text/'.($this->html?'html':'plain').'; charset="'.$d->Encoding().'"'.
			"\r\nContent-Transfer-Encoding: 7bit\r\n";

		if ($this->html) {
			$message = "\r\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\"><html><head><meta content=\"text/html;charset=".$d->Encoding()."\"\n http-equiv=\"Content-Type\"></head><body>\r\n".htmlentities($message);
		}

		if (isset($this->attach)) {	// if this is an attachment the content-type will be inline
			$headers .= "MIME-Version: 1.0\r\n";
			$headers .= 'Content-Type: multipart/mixed;'."\r\n\t".
								"boundary=\"$boundary\"\r\n";
			$message = $ctype."\r\n".$message;
		} else {	// if this is not an attachment the content type will precede the message in headers
			$headers .= $ctype;
			$message = "\r\n".$message;
		}

//		else $message = entity_decode($message);

		$message = $intro.$message;
		if ($this->html)
			$message .= "</body></html>";

		$message.="\r\n\r\n";

		if (isset($this->attach)) {
			global $mime;
			if (!in_array($this->attach[0], $mime))
				$this->attach[0] = $mime['exe'];
			
			$message = $message.'--'.$boundary."\r\n".
						'Content-Type: '.$this->attach[0].";\r\n\tname=\"".$this->attach[1]."\"\r\n".
						'Content-Transfer-Encoding: base64'."\r\n".
						'Content-Disposition: attachment;'."\r\n\t".
						'filename="'.$this->attach[1].'"'."\r\n\r\n".
						chunk_split(base64_encode(file_get_contents($this->attach[2]))).
						"\r\n\r\n".'--'.$boundary."\r\n\r\n";
			global $d_root;
// the temporary file should be deleted automatically
//			include_once $d_root.'admin/classes/fs.php';
//			$fs = new FS(true);

//			$fs->unlink($this->attach[2]); // remove the temporary file
		}
		
/*		// DEBUG
		header('Content-Type: text/plain; charset="'.$d->Encoding().'"');
		$full = "To: ".$recipient."\nSubject: ".$this->_encode_header($this->_rfc2045_safe($subject))."\n\n".$headers.$message."\n.\n";
		die($full);	*/
		
		if (@mail( $recipient, $this->_encode_header($this->_rfc2045_safe($subject)), $message, $headers))
			return true;
		global $d;
		$d->log(LOG_WARNING, 'Could not send email using mail()');
		return false;
	}

} // Mail class

?>