<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}

class User {

var $id=false;
var $captcha_ok;
var $gid=0;
var $username='';
var $name='';
var $email='';
var $lang;
var $ip;
//groups 1 = registered , 2 = editor  , 3 = publisher , 4 = manager , 5 = admin

function _save_lang_cookie($lang) {
	$lifetime = time()+(60*15);
	$this->lang = $lang;
	setcookie( 'user_language', $lang, $lifetime);
}

function _remove_lang_cookie() {
setcookie( 'user_language', '', time()-3600 );
}

function _custom_lang() {
	global $d_root;
	/* start user change language */
	$lang = in('lang', __SQL|__PATH, $_GET, '', 2);
	if(!isset($lang{0})) {
		if(isset($_COOKIE['user_language']))
			$lang = in('user_language', __SQL|__PATH, $_COOKIE, '',2);
		else
			$lang = '';
	} else {
		//TODO: if the user is registered the change should be permanently saved
	}
	
	if (isset($lang{0})) {
		if(is_dir($d_root.'lang/'.$lang)) {
			$this->_save_lang_cookie($lang);
			return true;
		} else
			$this->_remove_lang_cookie();
	}
	/* end user change language */
	return false;
}

function recognize_lid() {
	global $d_root;
	$hdr = @$_SERVER["HTTP_ACCEPT_LANGUAGE"];
	if (empty($hdr)) return $GLOBALS['d_deflang'];

	if (!preg_match_all('/([a-z]{2})/', $hdr, $m))
		return 'en';

	foreach( $m[0] as $lid ) {
		$lang=strtolower($lid);
		if (is_dir($d_root.'lang/'.$lang))
			return $lang;
	}
	return $GLOBALS['d_deflang'];
}

function _valid_lang($lang) {
	if (is_dir($GLOBALS['d_root'].'lang/'.$lang))
		return $lang;
	return $this->recognize_lid();
}

function GetIP() {
	global $d_root;
	if (!isset($this->ip)) {
		include $d_root.'includes/retrieveIP.php';
		$this->ip = retrieveIP();
	}
	return $this->ip;
}

// the constructor
function User() {
	global $d_rand;
	// retrieve user id from session object
	if(isset($_SESSION[$d_rand.'uid'])	) {
		$this->id = $_SESSION[$d_rand.'uid'];
		global $conn;
		$row=$conn->GetRow('SELECT gid,name,username,password,email,lang FROM #__users WHERE id='.$this->id);
		if ($this->initlogin($row)) {
			$this->_custom_lang();
			$this->captcha_in();
			$finished = true;
		}
	} else $finished = false;
	
	if (!$finished) {
	
	$username = in_sql('cusername', $_COOKIE);
	if(isset($_COOKIE['cuid']) && isset($username) && isset($_COOKIE['cpassword'])) {
		global $conn,$d_rand;		
		$row=$conn->GetRow('SELECT id,gid,name,username,password,email,lang FROM #__users WHERE username=\''.$username.'\'');
		if (count($row)) {
			$pwd = in_sql('cpassword', $_COOKIE);
			if ($pwd===md5($d_rand.$row['password'])) {
				$this->id=$row['id'];
				$this->lang = $this->_valid_lang($row['lang']);
				if ($this->initlogin($row)) {
					$this->captcha_in();
					$finished = true;
				}
			}
		}
	}
	}
	
	if (!$finished) {
		if (!$this->_custom_lang())
			$this->lang = $this->recognize_lid();
		$this->captcha_in();
	}
}

function captcha_in() {
	global $d_CaptchaLogin,$d_rand;
	$this->captcha_ok = ((($this->gid > 0) and $d_CaptchaLogin) or
						(isset($_SESSION[$d_rand.'captcha']) &&
						isset($_POST['code']) &&
						($_SESSION[$d_rand.'captcha'] === md5(strtoupper(@$_POST['code'])))));
}

function initlogin(&$row) {
	global $d_rand,$d_cookiepath,$d_rand;

	$this->gid = $row['gid'];
	$this->name=$row['name'];
	$this->username=$row['username'];
	$this->email=$row['email'];
	
	if (!$this->_custom_lang())	
		$this->lang = $this->_valid_lang($row['lang']);
		
	if (!$this->lang) {
		trigger_error("Language not correctly set!\nThe database may be corrupted.");
		return false;
	}
	
	$_SESSION[$d_rand.'uid']=$this->id;
	
//	$etime=60*15; // fifteen minutes
	if(isset($_POST['remember'])) {
		$etime=3600*24*14;
		setcookie("cuid",'remember', time()+$etime,$d_cookiepath,$_SERVER['HTTP_HOST']);
	    setcookie("cusername",$row['username'], time()+$etime,$d_cookiepath,$_SERVER['HTTP_HOST']);
	    setcookie("cpassword",md5($d_rand.$row['password']), time()+$etime,$d_cookiepath,$_SERVER['HTTP_HOST']);
	}
	return true;
}

function logout()
{
	global $d,$conn,$d_cookiepath,$my,$d_stats,$d_rand;
	setcookie("cuid","", time()-3600*24*14,$d_cookiepath,$_SERVER['HTTP_HOST']);
	setcookie("cusername","", time()-3600*24*14,$d_cookiepath,$_SERVER['HTTP_HOST']);
	setcookie("cpassword","", time()-3600*24*14,$d_cookiepath,$_SERVER['HTTP_HOST']);
	if ($d_stats)
		$conn->Execute("DELETE FROM #__simple_stats WHERE id>1 AND ip='".$my->GetIP()."'");
	unset($_SESSION[$d_rand.'uid']);
	$d->Redir($this->PreviousPage(true));
}

function PreviousPage($out = false) {
	global $d_website;
	// go back to the previous admin page (if any)
	$redir = strtolower(@$_SERVER['HTTP_REFERER']);
	if (strpos($redir, $d_website)===0) {
		$redir = substr($redir, strlen($d_website));
		if ($redir{0}=='/') $redir = substr($redir, 1);
		if (strpos($redir, 'index.php')===0)
			return $redir;
		if (strpos($redir, 'admin.php')===0) {
			if ($out)	return 'index.php';
			return $redir;
		}
	}
	return 'index.php';
}

function login()
{
	global $conn,$d,$time,$my,$d_rand;
	//L: added DRACON initialization
	if ('' === ($username = trim(in_sql('username', $_POST, '', 25))) ||
		'' === ($password = in_raw('password', $_POST, '', 100)) )
		$d->Redir('index.php?option=login', _LOGIN_INCOMPLETE);

	$danger = @($_SESSION[$d_rand.'trials']-50) % 50;
	if ($danger>0) {
		$_SESSION[$d_rand.'trials']++;
		$d->log(LOG_WARNING, 'Massive login trials ('.$_SESSION[$d_rand.'trials'].' attempts)');
		$d->Redir('index.php?option=login', _LOGIN_INCORRECT);
	}

$rsa = $conn->GetRow("SELECT * FROM #__users WHERE username = '".$username."' AND password = '".
					md5($password)."'");
if (!$rsa) {
	//L: added brute force attacks log messages
	if (!isset($_SESSION[$d_rand.'trials']))
		$_SESSION[$d_rand.'trials'] = 0;
	$_SESSION[$d_rand.'trials']++;
	if ($_SESSION[$d_rand.'trials'] > 50)
		$d->log(LOG_WARNING, 'Massive login trials (first warning)');
	$d->Redir('index.php?option=login', _LOGIN_INCORRECT);
}
	$_SESSION[$d_rand.'trials'] = 0;

	if (!$rsa['published'])
		$d->Redir('index.php?option=login', _LOGIN_BLOCKED);

	$this->id=$rsa['id'];
	global $d_stats;
	if ($d_stats)
		$conn->Execute("DELETE FROM #__simple_stats WHERE id>1 AND ip='".$my->GetIP()."'");
	$this->initlogin($rsa);
	if ($d_stats)
		$conn->Execute("UPDATE #__users SET lastvisitDate ='".$time."' WHERE id = ".$this->id);
	$d->Redir($this->PreviousPage());
}

//L: need to be reworked
function valid_captcha() {
	global $d;
	if (!$this->captcha_ok) {
		$d->Back(_CAPTCHA_INCORRECT_CODE);
		return false;
	}
	return true;
}

function admin_login()
{
global $conn,$d,$d_CaptchaAdmin;
$username = trim(in_sql('login_user', $_POST, null, 25));
$password = md5(in_raw('login_password', $_POST, '', 20));
if ($d_CaptchaAdmin and !$this->valid_captcha()) return;

$row=$conn->GetRow("SELECT id,name,username,published,gid,lang FROM #__users WHERE username = '".$username."' AND password = '".$password."'");
if($row) {
	if(!$row['published'])
		die("Your Login has been blocked");
	$this->id=$row['id'];
//	session_unset();	//L: RFC
	$this->initlogin($row);
}
}
function isuser()
{
	if($this->id)
		return true;
	else
		return false;
}

function isadmin()
{
	return ($this->gid==5);
}

function isauth($action)
{
	global $d_admin_level;
	if (($this->gid >= 1) and ($this->gid < 5))
		return (strpos($d_admin_level[$this->gid], $action)!==false);
	else if ($this->gid == 5) {
			if ($action == 'admin_subsites')
				return (!isset($GLOBALS['d_subpath']{0}));
			else
				return true;
	}
	return false;
}

function register($reg_name,$reg_email,$reg_user,$reg_password)
{
global $conn, $time, $d;

	/* check for username and email */
	$urow=$conn->Execute("SELECT id FROM #__users WHERE username='".sql_encode($reg_user)."'");
	if ($urow && $urow->RecordCount()>0)
		$d->Redir('index.php?option=registration', _UNAME_INUSE);
	$urow=$conn->Execute("SELECT id FROM #__users WHERE email='".sql_encode($reg_email)."'");
	if($urow && $urow->RecordCount()>0)
		$d->Redir('index.php?option=registration', _REGWARN_EMAIL_INUSE);

	$conn->Execute('INSERT INTO #__users (name,username,email,password,registerDate,lastvisitDate,lang) '.
	'VALUES (\''.sql_encode($reg_name)."','".sql_encode($reg_user)."','".sql_encode($reg_email)."','".
	md5($reg_password)."','$time','$time','".$this->lang."')" );
}

}

?>
