<?php
## Download proxy for Drake CMS
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# this file must not to be included
# custom file download server for .php protected files
#

define( "_VALID", 1 );
define( "_VALID_ADMIN", 1 );

require 'version.php';

include $d_root.'admin/includes/header.php';

if ( ('' === ($dir = in_path('dir', $_GET, 'public'))) ||
	('' === ($fn = in_path('fn', $_GET, ''))) ) {
		header('Status: 400 Bad Request');
		exit;
}

if ($dir == 'backup') {
	if ($my->gid < 5) {
		header('Status: 403 Forbidden');
		exit;
	}
	$dir = $d_private.'backup/';
} else if ($dir == 'public')
	$public.='/';
else {
	header('Status: 400 Bad Request');
	exit;
}

if (!file_exists($d_root.$dir.$fn)) {
	header('Status: 404 Not Found');
	exit;
}

if (file_ext($d_root.$dir.$fn)!='php') {
	$f = fopen($d_root.$dir.$fn, 'rb');
	$dl_fn = $fn;
	$gid = 0; // because minimal GID already checked above
} else {
	$dl_fn = substr($fn,0,-4);

	$hdr = open_pdl($d_root.$dir.$fn, $ofs);
	if (!isset($hdr[0])) {
		fclose($f);
		header('Status: 415 Unsupported Media Type');
		exit;
	}
	$gid = $hdr[0];
}

// we should also have GID on the filename
if ($my->gid<$gid) {
	fclose($f);
	header('Status: 403 Forbidden');
	exit;
}

$d->ResponseStart();

include $d_root.'includes/download.php';

if (null === ($xtype = @$mime[file_ext($dl_fn)]))
	$xtype = $mime[''];

send_download_headers($dl_fn, filesize($d_root.$dir.$fn)-$ofs, $xtype);

readfile($d_root.$dir.$fn);
?>