<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Download function
# @author legolas558
# Released under GNU GPL License
# This component is part of Drake CMS core
#
# utility function to correctly server for download binary/ASCII files
#

function send_download_headers($dl_filename, $filesize, $xtype) {
	header("Content-Transfer-Encoding: binary");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Content-Type: ".$xtype);
	header("Accept-Ranges: bytes");
	header("Content-Disposition: attachment; ".
		   "filename=".$dl_filename.";");	//L: will have troubles with some filenames iirc
	header("Content-Length: ".$filesize);
}

static $mime = array(
//		'' => 'application/force-download',
		'' => 'application/octet-stream',		// some browser may have issues with force-download
		'mp3' => 'audio/mpeg',
		'tgz' => 'application/x-tar',
		'zip' => 'application/x-zip-compressed',
		'exe' => 'application/octet-stream',
		'txt' => 'text/plain',
		'sql' => 'text/sql',
		'doc' => 'application/msword',
		'xls' => 'application/vnd.ms-excel',
		'ppt' => 'application/vnd.ms-powerpoint',
		'gif' => 'image/gif',
		'png' => 'image/png',
		'jpg' => 'image/jpeg',
		'jpeg' => 'image/jpeg',
		'wav' => 'audio/x-wav',
		'mpg' => 'video/mpeg',
		'mpeg' => 'video/mpeg',
		'avi' => 'video/x-msvideo',
		'mov' => 'video/quicktime'
		);

function download($filename, $filesize, $ovveride_fn=null) {

	if (!($xtype = @$mime[file_ext($filename)]))
		$xtype = $mime[''];
	
	if (!isset($ovveride_fn))	$override_fn=basename($filename);

	send_download_headers($ovveride_fn, $filesize, $xtype);

	readfile($filename);
}

?>