<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## PHP error tracer
# @author legolas558
#
# gives a debug backtrace for caught errors

function Drake_error_handler ($errno, $errstr, $orig_errfile, $orig_errline) {
  $errlevel = error_reporting();
  if (!($errno & $errlevel)) return;
  if (($errno == 8) && ($errlevel<2048))
	return;	// we ignore this type of notices since revision 658

function fix_path($path) {
  global $d_root;
  $p = substr($path,0,strlen($d_root)-1);
  if(strpos($path,$p)!==false)
	$path=substr($path,strlen($p)+1);
  return str_replace('\\','/',$path);
}

function fix_string($s, &$len) {
	global $d_root;
	$copy_s = str_replace('\\', '/', $s);
	if (strpos($copy_s, '"'.$d_root)===0) {
		$s = '$d_root."'.substr($copy_s, strlen($d_root)+1);
		$len = '+'.(strlen($copy_s)-strlen($d_root));
	} else $len=strlen($s);
	if (strlen($s) > 255)
		return substr($s, 0, 255).'...';
	else return $s;
}

function list_args($args) {
	if (empty($args))
		return '';
	global $my;
	if (@$my->gid!=5)
		return count($args);
	$r = '';
	foreach ($args as $arg) {
		$t = gettype($arg);
		if ($t == 'object') $t = get_class($arg);
		elseif ($t == 'string') {
			$arg = fix_string('"'.$arg.'"', $len);
			$t.='<sub>['.$len.']</sub> = '.$arg;
		} elseif (($t == 'integer') or ($t == 'double')) $t.=' = '.$arg;
		elseif ($t=='boolean') $t.=' = '.($arg?'true':'false');
		elseif ($t=='array') $t.='<sub>['.count($arg).']</sub>';
		$r.=$t.', ';
	}
	if (strlen($r))
		return substr($r, 0, -2);
	else
		return $r;
}

  global $d_subpath, $d_error_report;
	if ($d_error_report>=1) { ?>
		</table>
		<div id="errorinfo" style="text-align: left; background-image: url(<?php echo $d_subpath; ?>images/common/crack.png);  background-position: right top; background-repeat: no-repeat; background-color:white; border: 3px solid;">
		<h1 style="text-align:center">Drake unhandled error</h1>
		<p>Begin copying right after the scissors:</p>
		<?php
		echo '<img src="'.$d_subpath.'images/common/cut.png"><hr>';
	}

	// analyze the debug backtrace
	$hashlet = '';
	$errline = $orig_errline;
	$errfile = $orig_errfile;
	$lines = array();
	
	if ($dbg = @debug_backtrace()) {
		$c = count($dbg);
		for ($i=$c-1;$i>1;$i--) {
			$path = @fix_path($dbg[$i]['file']);
			global $d_db;
			if (($d_db!='gladius') && strpos($path, 'dbfork.php')) {
				if (!isset($dbg[$i+1]['line']))
					$errline = 'unknown';
				else
					$errline = $dbg[$i+1]['line'];
				$errfile = '';
				$errstr = 'E'.$errno.': '.$errstr;
				$hashlet .= "$path($errline):E$errno\n";
				break;
			}
			if (!isset($dbg[$i]['line']))
				$line = 'unknown';
			else
				$line = $dbg[$i]['line'];
			$lines[] = $path.'('.$line.'): '.
					$dbg[$i]['function'].'('.list_args(@$dbg[$i]['args']).')';
			$hashlet .= "$path($line):".$dbg[$i]['function']."\n";
		}
	}
	$last = fix_path($errfile);
	if ($errfile !== '') {
		$hashlet .= "$last($errline):E$errno\n";
		$last .= "($errline): E$errno";
	}
	if ($errfile !== '') $last .= ' ';
	$last .= $errstr;
	
	if (strlen($hashlet)>0 && $dbg) {
		$ehash = pack('H*', md5($hashlet));
		unset($hashlet);
		$l=strlen($ehash);
		$nhash='';
		for($i=0;$i<$l;$i=$i+4) {
			$sum = ord($ehash{$i})+ord($ehash{$i+1})+ord($ehash{$i+2})+ord($ehash{$i+3});
			$conv = base_convert($sum,10,36);
			if (!isset($conv{1})) $conv='0'.$conv;
			$nhash.=$conv;
		}
		$ehash=strtoupper($nhash);
	}
	else $ehash = '';
	if ($d_error_report>=1) {
		echo "<h3>==Error hash==</h3>\n&nbsp;$ehash\n";
		echo "\n<h3>==Previous page==</h3>\n";
		$ref = strtolower(@$_SERVER['HTTP_REFERER']);
		if (strlen($ref)) {
			global $d_website;
			if (strpos($ref, strtolower($d_website))===0) {
				$ref = substr($ref, strlen($d_website));
				echo $ref;
			} else { $ref = ''; echo '<i>invalid</i>'; }
		} else { $ref =''; echo '&nbsp;-'; }
		echo '<h3>==Version information==</h3>';
		ob_start();
		version_info();
		echo "\n<h3>==Debug backtrace==</h3>\n<pre>";
		echo implode("\n", $lines);
	}
	unset($lines);
	if ($d_error_report>=1) {
		?>	<div style="font-size:16px; background-color: black; color:cyan"><?php
		echo $last.'</div></pre>';
		$error = strip_tags(ob_get_contents());	// copy the error message
		ob_end_flush();
		echo '<hr><img src="'.$d_subpath.'images/common/cut.png">';?>
		<p>Once copied all the above informations,</p>
		<h3><a href="http://drakecms.sourceforge.net/error.php?ehash=<?php echo $ehash; ?>" target="_blank" title="Investigate about this error">Click here to check if the error has already been reported and/or fixed</a></h3>
		<h4>We are sorry for the inconvenience; thanks for your collaboration.</h4><?php
		// error submission webservice not yet active (cannot yet submit to sourceforge)
		if ($dbg && false) {
		$lines[] = $last;	?>
		<h3>Error submission</h3>
		<form name="errform" method="POST" action="http://drakecms.sourceforge.net/error.php?ehash=<?php echo $ehash; ?>">
			<input type="hidden" name="edata" value="<?php echo urlencode($error."\n==Previous page==\n$ref\n"); ?>">
			<p>Press the below button to submit the above error information.</p>
			<p>Specify what you were doing before the error happened<?php
			if ($ref!=='') {?>(you came from page <a target="_blank" href="<?php echo $ref; ?>"><?php echo $ref; ?></a>)<?php }
			?></p>
			<p>&nbsp;<textarea name="comment" cols="35" rows="3"></textarea></p>
			<input type="submit">
		</form>
		<?php }
		echo '</div>';
		die;
	} else {
		echo '<a href="http://drakecms.sourceforge.net/error.php?ehash='.$ehash.'" target="_blank" title="Investigate about this error"><img src="'.$d_subpath.'images/common/buggie.png" border="0" alt="ERROR" width="32" height="42" /></a>';
		return false;
	}

}

?>
