<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Misc. Drake functions
#
# file-related functions should be separated in a different class

if (!defined('DATE_RSS'))
	define('DATE_RSS', 'r');

if (!function_exists('ctype_digit')) {

function ctype_digit($s) {
//	settype($s, 'string');
	$l=strlen($s);
	for($i=0;$i<$l;$i++) {
		$o = ord($s{$i});
		if (($o <= '0') || ($o >= '9')) return false;
	}
	return true;
}

function ctype_alpha($s) {
//	settype($s, 'string');
	$l=strlen($s);
	for($i=0;$i<$l;$i++) {
		$o = ord($s{$i});
		if (!(
			(($o >= 'a') && ($o <= 'z')) ||
			(($o >= 'A') && ($o <= 'Z')) ))
		return false;
	}
	return true;
}

function ctype_alnum($s) {
//	settype($s, 'string');
	$l=strlen($s);
	for($i=0;$i<$l;$i++) {
		$o = ord($s{$i});
		if (!(
			(($o >= '0') && ($o <= '9')) ||
			(($o >= 'a') && ($o <= 'z')) ||
			(($o >= 'A') && ($o <= 'Z')) ))
		return false;
	}
	return true;
}

}

if (!function_exists('file_get_contents')) {

function file_get_contents($path) {
	$f = @fopen($path, 'rb');
	if ($f===FALSE)
		return FALSE;
	$sz = filesize($path);
	if (!$sz) {
		fclose($f);
		return '';
	}
	$rd = fread($f, $sz);
	fclose($f);
	return $rd;
}

}

// detect windows OS on server
if (stristr(@php_uname(), 'windows'))
	$GLOBALS['d__windows'] = 1;
else {
	if (stristr(@$_SERVER['OS'], 'windows'))
		$GLOBALS['d__windows'] = 1;
	else
		$GLOBALS['d__windows'] = 0;
}

function is_windows() {
	return $GLOBALS['d__windows'];
}

function is_url(&$s) {
	return (preg_match('/[\\w\\+]+\\:\\/\\//A', $s) > 0);
}

function change_val($table, $id, $field, $change = 1) {
	global $conn;
	$rsa = $conn->GetRow("SELECT $field FROM #__$table WHERE id = $id");
	$val = $rsa[$field] + $change;
	$conn->Execute("UPDATE #__$table SET $field=$val WHERE id = $id");
	return $val;
}

function get_domain($ext=false) {
	global $d_website;
	$domain = substr($d_website,strpos($d_website,'//')+2);
	$sl=strpos($domain,'/');
	if($sl!==false)$domain=substr($domain,0,$sl);
	$p=strpos($domain,'.');
	if($p!==false) {
		if ($ext)
			$domain = substr($domain, $p+1);
		else {
			$p2=strpos($domain,'.',$p+1);
			if($p2!==false)$domain=substr($domain,$p+1,$p2-$p-1);
		}
	}
	return $domain;
}

function is_email( $email ){
	return ( preg_match( "/[\w\.\-]+@\w+[\w\.\-]*?\.\w{1,4}/", $email ) );
}

function file_ext($file)
{
	$p = strrpos($file, '.');
	if ($p===false)return '';
	return strtolower(substr($file,$p+1));
}

function read_dir($dir,$type='both',$extra=false,$allowed_ext=false)
{
	$info=array();
	$dh=opendir($dir);
	$infod=array();$infof=array();
	while (false !== ($d_name = readdir($dh))) {
		if( $d_name{0}=='.' ) continue;
		if ( is_dir( $dir.$d_name ) && ( $type=='dir' || $type=='both') ) {
			if($extra) {
				$tinfo['id']=substr($d_name,strrchr($d_name,'/'));
				$tinfo['path']=$dir.$d_name."/";
				$tinfo['size']='NA';
				$tinfo['perms']=getPerms(fileperms($tinfo['path']));
				$tinfo['created']=filectime($dir.$d_name);
				$infod[]=$tinfo;
			} else $infod[]=$d_name;
		}
		
		if ( is_file( $dir.$d_name ) && ( $type=='file' || $type=='both')  ){
			if (!$allowed_ext or (in_array(file_ext($dir.$d_name), $allowed_ext))) {
				if($extra) {
					$tinfo['id']=substr($d_name,strrchr($d_name,'/'));
					$tinfo['path']=$dir.$d_name;
					$tinfo['size']=convert_bytes(filesize($dir.$d_name));
					$tinfo['perms']=getPerms(fileperms($tinfo['path']));
					$tinfo['created']=filectime($dir.$d_name);
					$infof[]=$tinfo;
				} else
					$infof[]=$d_name;
			}
		}
	}
	$info=array_merge($infod,$infof);
	return $info;
}

if (ini_get('allow_url_fopen')) {

	function get_url($url,$file=null) {
		$rd = @file_get_contents($url);
		if ($rd===false) return false;
		if (isset($file)) {
			$f = fopen($file, 'wb');
			fwrite($f, $rd);
			fclose($f);
			return true;
		} else
			return $rd;
	}

} else {

	function get_url($url,$file=null) {
		global $classes_dir;
		require_once($classes_dir.'sst.php');
		$downloader = new classDownloader;
		return $downloader->Download($url,$file);
	}

}

//L: returns an unix timestamp from a calendar formatted date
function format_date($fmt_date)
{
	sscanf($fmt_date,"%d-%d-%d %d:%d:%d",$year,$month,$day,$hour,$minute,$second);
	return mktime ($hour,$minute,$second,$month,$day,$year);
}

function search_ext($hay,$needle,$op)
{
		$needle=trim($needle);
		$search_arr=explode(" ",$needle,strlen($needle));
	switch($op)
{
		case "any":
			{
			foreach($search_arr as $keyword)
			{
			if(stristr(html_to_text($hay),$keyword))
				{
				return true;
				}
			}
			break;
			}
		case "all":
			{
			$all_present=true;
			foreach($search_arr as $keyword)
			{
			if(!stristr(html_to_text($hay),$keyword))
			{
			$all_present=false;
			break;
			}
			}
			if($all_present)return true;
			break;
			}
		case "exact":
			{
			if(strstr(html_to_text($hay),$needle))return true;
			break;
			}
}
return false;
}

function select(&$data,$value)
{
	if (is_array($value)) {
		for($i=0;$i<count($data);$i++) {
			if(in_array($data[$i]['value'],$value)) {
				$data[$i]["selected"]="true";
				break;
			}
		}
	} else {
		for($i=0;$i<count($data);$i++) {
			if($data[$i]['value']==$value) {
				$data[$i]["selected"]="true";
				break;
			}
		}
	}
	return $data;
}

/*static */function usr_rel_com_path($file,$com=null) {
	if (!isset($com))	$com = $GLOBALS['com_name'];
	return "components/com_$com/".$com.'.'.$file;
}

function usr_com_path($file,$com=null) {
	return $GLOBALS['d_root'].usr_rel_com_path($file,$com);
}

if(defined( '_VALID_ADMIN' )) {

	function rel_com_path($file, $com=null) {
		if (!isset($com))	$com = $GLOBALS['com_name'];
		return "admin/components/com_$com/admin.$com.$file";
	}

	/*static */ function com_path($file,$com=null) {
		return $GLOBALS['d_root'].rel_com_path($file,$com).'.php';
	}

} else {

	function rel_com_path($file, $com=null) {
		return usr_rel_com_path($file,$com);
	}

	/*static */ function com_path($file,$com=null) {
		return usr_com_path($file,$com).'.php';
	}

}

function com_lang($lang, $com=null) {
	global $d_root,$com_name;
	if ($com===null)$com=$com_name;
	$path='components/'.$com.'.php';
	if(defined( '_VALID_ADMIN' ))
		return $d_root.'lang/'.$lang.'/admin/'.$path;
	else
		return $d_root.'lang/'.$lang.'/'.$path;
}

function mod_lang($lang, $mod) {
	global $d_root;
	return $d_root.'lang/'.$lang.'/modules/'.$mod.'.php';;
}

function bot_lang($lang, $bot) {
	global $d_root;
	return $d_root.'lang/'.$lang.'/drabots/'.$bot.'.php';;
}

//L: returns the template image (if available) or the default one
function ImageCheck($file,$dir) {
global $d,$d_root,$d_template;
	$d_template_dir=$d_root."templates/".$d_template;
	if(is_file($d_template_dir.$dir.$file))return '<img src="'.$d_template.$dir.$file.'" border="0" alt="" />';
	return '<img src="'.$dir.$file.'" border="0" alt="" />';
}

//L: enhanced
function random_string($len) {
	$salt = "abchefghjkmnpqrstuvwxyz0123456789";
	mt_srand((double)microtime()*1000000);
	$i = 0;
	$rand='';
	for ($i=0;$i<$len;$i++)
		$rand .= $salt[mt_rand(0, 32)];
	return $rand;
}

function return_bytes($val) {

	$val = trim($val);
	$i = 0; $l = strlen($val);
	while ($i<$l && (!ctype_alpha($val{$i}))) {
		$i++;
	}
	$pf = strtolower(trim(substr($val,$i)));
	$val=(float)substr($val,0,$i);
		
	if (isset($pf{0})) {
		switch($pf{0}) {
	       case 'g':
	           $val *= 1024;
	       case 'm':
	           $val *= 1024;
	       case 'k':
	           $val *= 1024;
	   }
   }
   return $val;
}

function convert_bytes($val) {
	$val=(float)$val;
	if ($val < 1024)
		return $val;
	$k = $val / 1024;
	if ($k >= 1024) {
		$m = $k / 1024;
		if ($m >= 1024)
			$n = number_format($m/1024,2).' GB';
		else
			$n = number_format($m,2).' MB';
	} else
		$n = number_format($k,2).' KB';
	return str_replace('.00', '', $n);
}

function str_decode($s) {
	return str_replace(array('\\n', '\\\'', '\\"', '\\r', '\\t', '\\$', '\\\\'), array("\n", "'", '"', "\r", "\t", '$', '\\'), $s);
}

// provides a suffix for URLs containing title keywords
function content_sef($title) {
	global $d_seo;
	if (!$d_seo)
		return '';
	$title = preg_replace('/[^\\s\\w\\d]+/', '', $title);
	$title = preg_replace('/\\s+/', '-', trim($title));
	return '&amp;/'.substr($title, 0, $d_seo);
}

// provides a list of keywords from an XHTML content
function content_keywords($content) {
	$kl = preg_replace('/[^\\s\\w\\d]/', '', html_to_text($content));
	$kl = preg_replace('/\\s[^\\s]{1,3}\\s/U', ' ', ' '.$kl.' ');
	return preg_replace('/\\s+/', ',', trim($kl));	
}

$access_level=array(
	array('name'=>_USERS_GRP_0,'value'=>'0'),
	array('name'=>_USERS_GRP_1,'value'=>'1'),
	array('name'=>_USERS_GRP_2,'value'=>'2'),
	array('name'=>_USERS_GRP_3,'value'=>'3'),
	array('name'=>_USERS_GRP_4,'value'=>'4'),
	array('name'=>_USERS_GRP_5,'value'=>'5'),
	array('name'=>_USERS_GRP_9,'value'=>'9')
	);


function access_bygid($gid) {
	global $access_level;
	if (empty($gid)) return $access_level[0]['name'];
	foreach($access_level as $acl) {
		if ($acl['value']==$gid)
			return $acl['name'];
	}
	return $gid;
}

//L: from my Gladius DB
define('__QUOTED_S', "('[^']*')+");

define('_DRAKE_PDL_SIGNATURE', '/* @DKPDL %s @GID %s <?php if (@$my->gid<'.'%s)die; ?> */'."\n");
define('_DRAKE_PDL_SIGNATURE_RX', '/\\/\\* @DKPDL (\\d+\\.\\d+\\.?\\d?\\d?) @GID\\s+(\\d+) \\<\\?php if \\(@\\$my-\\>gid\\<\\s*(.\\d+)\\)die; \\?\\> \\*\\//i');

function open_pdl($fname) {
	$f = fopen($fname, 'rb');
	$hdr = array(null,null);
	$s = @fread($f, strlen(_DRAKE_PDL_SIGNATURE)+10);
	fclose($f);
	if (preg_match(_DRAKE_PDL_SIGNATURE_RX, $s, $m)) {
		$gid = (int)$m[2];
		if ($gid !== (int)$m[3]) {
			$p=strpos('?> */', $s);
			fseek($f, $p+5);
			return $f;
		}
		$hdr = array($gid,$m[1]);
	}
	return $hdr;
}

function drake_version() {
	global $d_version;
	preg_match('/\\d+\\.\\d+\\.?\\d+?/A', $d_version, $m);
	return $m[0];
}

function write_pdl_h($f, $gid) {
	settype($gid, 'string');
	if (strlen($gid)==1) $gid = ' '.$gid;
	fwrite($f, sprintf(_DRAKE_PDL_SIGNATURE, drake_version(), (int)$gid, $gid));
}

function page_nav($page_url,$count,$display,$class='pagenav',$type=0) {

	$page = in_num('page', $_REQUEST, 1);

	$num_pages = (int)($count/$display);
	if ($count % $display)
		$num_pages++;
	if($num_pages<2)
		return '';
	 if($page>1) // setup PREV link
		$previous="<a href='$page_url&amp;page=".($page-1)."&amp;rt=$count' class='$class'>"._ITEM_PREVIOUS."</a>";
		else
			$previous="<span class='$class'>"._ITEM_PREVIOUS.'</span>';
     if($page<$num_pages) // setup NEXT link
		$next='<a href="'.$page_url.'&amp;page='.($page+1).'&amp;rt='.$count.'"  class="'.$class.'">'._ITEM_NEXT.'</a>';
	else
		$next="<span class='$class'>"._ITEM_NEXT.'</span>';

     if($type==1)
		return "$previous  ( ".sprintf(_PN_PAGE, $page, $num_pages)." ) $next";
	if ($num_pages > 2) { // setup FIRST link
		 if($page>1)
			$first="<a href='$page_url' class='$class'>"._PREV_ARROW.' '._PN_START."</a>";
		else
			 $first="<span class='$class'>"._PREV_ARROW.' '._PN_START.'</span>';
	 } else
		$first = '';
		if ($num_pages > 2) { // setup LAST link
			if($page<$num_pages)$last="<a href=\"$page_url&amp;page=".$num_pages.'&amp;rt='.$count.'"  class="'.$class.'">'._PN_END.' '._NEXT_ARROW."</a>";
			else
				$last="<span class='$class'>"._PN_END.' '._NEXT_ARROW.'</span>';
		} else
			$last = '';

		$page_links='';
	for($pn=1;$pn<$page;$pn++) {
		$page_links.=" <a href=\"$page_url&amp;page=".$pn.'&amp;rt='.$count.'"  class="'.$class.'">'.$pn.'</a> ';
	}
	$page_links.="<span class=\"$class\">$page</span>";
	for($pn=$page+1;$pn<=$num_pages;$pn++ ) {
		$page_links.=" <a href=\"$page_url&amp;page=".$pn.'&amp;rt='.$count.'"  class="'.$class.'">'.$pn.'</a> ';
	}
	return "<p align=\"center\">$first $previous $page_links $next $last</p>";
}

function html_to_text($html) {
	return strip_tags(str_replace(array('<br />','<br/>','<br>'), "\n", str_replace('>', '> ', $html)));
}

function js_enc($s) {
	return addslashes($s);
}

?>