<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## common admin/user includes
# @author legolas558
#
# included files for each Drake CMS instance

function mt_float()
{
   list($usec, $sec) = explode(' ', microtime());
   return ((float)$usec + (float)$sec);
}

// { ***** DEBUG *****

$page_start_time = mt_float();

include $d_root.'includes/errtrace.php';

//L: only in debug releases!
set_error_handler('Drake_error_handler');

// ***** DEBUG ***** }

//L: in the beginning, there was no configuration, and the User installed Drake
if (!file_exists( $d_root.$d_private.'config.php' )) {
	header( "Location: install/index.php" );
	exit();
}

include $d_root.$d_private.'config.php';

//L: And the User forgot to rename/remove the install folder
if (is_dir($d_root.'install')) {
//L: but Drake showed itself being offline not to allow mailicous users to re-install
	header('Status: 500 Server Error');
	include $d_root.'includes/servererror.php';
	service_msg('Offline', $d_offline_msg);
	exit();
}

//L: specify 2048 for strict error reporting (PHP5)
error_reporting( 2047 );

@session_start();	//L: we do not complain if the session has already been started

$time = time() + $d_offset*60*60;	//L: Q: is it really working? possible bottlenecks?

$includes_dir=$d_root.'includes/';
$components_dir=$d_root.'components/';
$modules_dir=$d_root.'modules/';
$classes_dir=$d_root.'classes/';
$images_dir=$d_root.'images/';

include $d_root.'includes/dracon.php';

$d_type = 'html';	//L: a better HTML/XHTML diversification (in references to $d_type) is wanted

$d_cookiepath = getcookiepath();

function getcookiepath() {
	global $d_website;
	$hostlen = strlen($_SERVER['HTTP_HOST']);
	$findpath = substr($d_website,strpos($d_website,$_SERVER['HTTP_HOST'])+$hostlen);
	// $dir = strrchr(substr($d_root, 0, -1), '/');
	return $findpath;
}

include $d_root.'includes/adodb.php';

include $d_root.'classes/user.php';

$my = new User();

$edit_acl = 'editgroup<'.($my->gid+1);
$access_acl = 'access<'.($my->gid+1);
$access_sql='AND '.$access_acl;

include $d_root.'lang/'.$my->lang.'/common.php';

include $includes_dir.'functions.php';

include $classes_dir.'drake.php';

//L: create the drabots collection handler
$_DRABOTS = new DrabotHandler();

//L: the play begins
$d = new Drake();

//L: we have to optimize (even more) the below visit counter
//L: it should be disabled (at option) from the backend
//L: we should also have a brief statistic in the backend
//L: through it, if always enabled
if ($d_stats) {
	include $classes_dir."stats.php";
	$stats = new Stats();
}

include($d_root.'lang/'.$my->lang.'/user.php');

header('Content-Type: text/html; charset='.strtoupper($d->Encoding()));
header('Content-Language: '.$lang);

//L: $d_utf8 will be set at runtime and will tell if utf8 re-encoding of some PHP functions output is needed
global $d_utf8, $d_locale;
$d_utf8 = false;
$lids = explode("\n", _LOCALE);
foreach($lids as $lid) {
	$d_locale = setlocale(LC_ALL, array($lid.'.UTF8', $lid.'.UTF-8'));
	if ($d_locale!==false) {
		$d_utf8 = true;
		break;
	}
}
if (!$d_utf8) {	// provide a specific conversion function
	include $d_root.'includes/utf8.php';
} else {
	function lc_enc($s) { return $s; }
}

/*** ALLOWED GLOBALS SECTION ***/

$option = in_path('option', $_GET);

$Itemid = in_num('Itemid', $_GET, 0);

$catid = in_num('catid'); //L: needs more checking
?>