<?php if(!defined('_VALID')){header('Status: 404 Not Found');die;}
## Event calendar module
# @author Vikas Patial
#
# main module file
# JCauble - Left table here as trying to convert to CSS based would be a nightmare for compatibility
#

$bgcolor = @$params->get( 'bgcolor' ,'#ffff80') ;

global $time,$month,$year;

$content = "";

if (!function_exists('cal_days_in_month')) {
 /*
 * cal_days_in_month($month, $year)
 * Returns the number of days in a given month and year, taking into account leap years.
 *
 * $month: numeric month (integers 1-12)
 * $year: numeric year (any integer)
 *
 * Prec: $month is an integer between 1 and 12, inclusive, and $year is an integer.
 * Post: none
 */
  // corrected by ben at sparkyb dot net
  function cal_days_in_month($month, $year)
  {
  // calculate number of days in a month
  return $month == 2 ? ($year % 4 ? 28 : ($year % 100 ? 29 : ($year % 400 ? 28 : 29))) : (($month - 1) % 7 % 2 ? 30 : 31);
  }
}

// Gather variables from
// user input and break them
// down for usage in our script

if(!isset($month))$month=date("m",$time);
if(!isset($year))$year=date("Y",$time);


$date = mktime(0,0,0,$month,1,$year);

$day = date('j', $date);
$month = date('n', $date);
$year = date('Y', $date);

// Get the first day of the month
$month_start = mktime(0,0,0,$month, 1, $year);
$month_end = mktime(0,0,0,$month+1,1, $year);

// Get friendly month name
$month_name = lc_enc(ucfirst(strftime('%B', $month_start)));

// Figure out which day of the week
// the month starts on.
$month_start_day = lc_enc(ucfirst(strftime('%a', $month_start)));

function dow($d) {
	return lc_enc(ucfirst(strftime('%a', 60*60*24*(4+$d))));
}

for ($offset=0;$offset<7;$offset++) {
	if (dow($offset)==$month_start_day)
		break;
}

function dowi($d) {
	return lc_enc(ucfirst(strftime('%a', 60*60*24*(4+$d))));
}

// determine how many days are in the last month.
if($month == 1){
   $num_days_last = cal_days_in_month(0, 12, ($year -1));
} else {
   $num_days_last = cal_days_in_month(0, ($month -1), $year);
}
// determine how many days are in the current month.
$num_days_current = cal_days_in_month(0, $month, $year);

// Build an array for the current days
// in the month
for($i = 1; $i <= $num_days_current; $i++){
    $num_days_array[] = $i;
}

// Build an array for the number of days
// in last month
for($i = 1; $i <= $num_days_last; $i++){
    $num_days_last_array[] = $i;
}

// If the $offset from the starting day of the
// week happens to be Sunday, $offset would be 0,
// so don't need an offset correction.

if($offset > 0){
    $offset_correction = array_slice($num_days_last_array, -$offset, $offset);
    $new_count = array_merge($offset_correction, $num_days_array);
    $offset_count = count($offset_correction);
}

// The else statement is to prevent building the $offset array.
else {
    $offset_count = 0;
    $new_count = $num_days_array;
}

// count how many days we have with the two
// previous arrays merged together
$current_num = count($new_count);

// Since we will have 5 HTML table rows (TR)
// with 7 table data entries (TD)
// we need to fill in 35 TDs
// so, we will have to figure out
// how many days to append to the end
// of the final array to make it 35 days.


if($current_num > 35){
   $num_weeks = 6;
   $outset = (42 - $current_num);
} elseif($current_num < 35){
   $num_weeks = 5;
   $outset = (35 - $current_num);
}
if($current_num == 35){
   $num_weeks = 5;
   $outset = 0;
}
// Outset Correction
for($i = 1; $i <= $outset; $i++){
   $new_count[] = $i;
}

// Now let's "chunk" the $all_days array
// into weeks. Each week has 7 days
// so we will array_chunk it into 7 days.
$weeks = array_chunk($new_count, 7);


///Get all the event for the current month
global $conn,$access_sql;

$event_array=array();
//$result=sql_query("SELECT eventid,event_name,date_start,date_end FROM ".$prefix."_event_list WHERE date_start >= '$month_start' AND date_start <= '$month_end' ",$dbi);
$sql="SELECT id,title,sdate,edate,published FROM #__event WHERE edate >= '$month_start' AND sdate <= '$month_end' AND published=1";
$rsa=$conn->GetArray($sql);
if (count($rsa)) {
foreach($rsa as $res)
{
  $eventid=$res['id'];

  if (date("Y",$date)==date("Y",$res['sdate']))
  $date_start=date("z",$res['sdate']);
	else
	$date_start=0;
  if (date("Y",$date)==date("Y",$res['edate']))
  $date_end=date("z",$res['edate']);
	else
	$date_end=365;

  for($ke=$date_start;$ke<=$date_end;$ke++)
  {
  if(!isset($event_array[$ke])){ $event_array[$ke]['title']=$res['title'];
  $event_array[$ke]['id']=$eventid;
  	}
    else $event_array[$ke]['title'].="\n".$res['title'];
  }
}
}

// Build Previous and Next Links
$previous_link = "<a href=\"index.php?option=event&amp;month=";
if($month == 1){
   $previous_link .= date("n",mktime(0,0,0,12,$day,($year -1)))."&amp;year=".date("Y",mktime(0,0,0,12,$day,($year -1)));
} else {
   $previous_link .= date("n",mktime(0,0,0,($month -1),$day,$year))."&amp;year=".date("Y",mktime(0,0,0,($month -1),$day,$year));
}
$previous_link .= "\">"._PREV_ARROW._PREV."</a>";

$next_link = "<a href=\"index.php?option=event&amp;month=";
if($month == 12){
   $next_link .= date("n",mktime(0,0,0,1,$day,($year + 1)))."&amp;year=".date("Y",mktime(0,0,0,1,$day,($year + 1)));
} else {
   $next_link .= date("n", mktime(0,0,0,($month +1),$day,$year))."&amp;year=". date("Y", mktime(0,0,0,($month +1),$day,$year));
}
$next_link .= "\">"._NEXT._NEXT_ARROW."</a>";

// Build the heading portion of the calendar table
$content.= "<table cellpadding=\"0\" cellspacing=\"2\" width=\"100%\">\n".
	"<tr>\n".
	"<td colspan=\"7\">\n".
	"<table align=\"center\" width=\"100%\">\n".
	"<tr>\n".
	"<td colspan=\"2\"  align=\"left\" nowrap=\"nowrap\">$previous_link</td>\n".
	"<td colspan=\"3\"  align=\"center\" nowrap=\"nowrap\">$month_name $year</td>\n".
	"<td colspan=\"2\"  align=\"right\" nowrap=\"nowrap\">$next_link</td>\n".
	"</tr>\n".
	"</table>\n".
	"</td>\n".
	"</tr>\n".
	"<tr align=\"center\">\n".
	"<td>".dowi(0)."</td>
	<td>".dowi(1)."</td>
	<td>".dowi(2)."</td>
	<td>".dowi(3)."</td>
	<td>".dowi(4)."</td>
	<td>".dowi(5)."</td>
	<td><font color=\"red\">".dowi(6)."</font></td>\n".
	"</tr>\n";

// Now we break each key of the array
// into a week and create a new table row for each
// week with the days of that week in the table data

$i = 0;
foreach($weeks AS $week){
       $content.= "<tr align=\"center\">\n";
       foreach($week as $d){
         if($i < $offset_count){
			$content.= "<td>&nbsp;</td>\n";

         }
         if(($i >= $offset_count) && ($i < ($num_weeks * 7) - $outset)){
            $daynum=date("z",mktime(0,0,0,$month,$d,$year));
			$event='';
			$day_link = $d;
			if(isset($event_array[$daynum])){
			$event=" bgcolor='$bgcolor' " ;
			$day_link = "<a href=\"index.php?option=event&amp;month=".$month."&amp;year=".$year."\" title=\"".$event_array[$daynum]['title']."\">$d</a>";
			}
           if(mktime(0,0,0,date("n"),date("j"),date("Y") ) == mktime(0,0,0,$month,$d,$year)){
               $content.= "<td $event ><strong>$day_link</strong></td>\n";
           } else {
               $content.= "<td $event >$day_link</td>\n";
           }
        } elseif(($outset > 0)) {
            if(($i >= ($num_weeks * 7) - $outset)){
			  $content.= "<td>&nbsp;</td>\n";
           }
        }
        $i++;
      }
      $content.= "</tr>\n";
}

// Close out your table and that's it!
$content.= '<tr><td colspan="7" class="days"></td></tr>';
$content.= '</table>';

echo $content;

?>